{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit GlsMathAttractors;

interface

procedure LimitCycles(Which,TimeStep: Integer);
{Procedure Rayleigh;
Procedure VanderPol;
Procedure Brusselator;}


procedure Lorenz(TimeStep: Integer);
procedure Strange(TimeStep: Integer); {Vortex}
procedure Duffing(TimeStep: Integer);
procedure Rossler(TimeStep: Integer);
procedure Henon_Attractor(TimeStep: Integer);

//These 3 NOT HERE YET
procedure Kaneko1
  (KanA {01.3}, KanD {0.1}, KanStep {0.01}: Extended;
  DisKan {30}, KanTeen {3000},TimeStep: Integer);
procedure Kaneko2
  (KanA {0.3}, KanD {1.75}, KanStep {0.02}: Extended;
  DisKan {36}, KanTeen {3000},TimeStep: Integer);
procedure Henon2(Target, KamStep {1.2;}: Extended;
Incoming {26},TimeStep:  Integer);
{Procedure Henon2;}{Limits 333 Henons Henon Range 1 Henon  >>>>}



procedure SetChemical(TimeStep: Integer);
procedure StrangeChemicalsa(TimeStep: Integer);
procedure StrangeChemicalsb(TimeStep: Integer);
procedure StrangeChemicalsc(TimeStep: Integer);
procedure StrangeChemicalsd(TimeStep: Integer);
procedure StrangeChemicalse(TimeStep: Integer);
procedure StrangeChemicalsf(TimeStep: Integer);
procedure StrangeChemicalsg(TimeStep: Integer);


implementation
uses math{power},GlsMathingsFrm;
(*****************************************************************)
{Rayleigh;VanderPol;Brusselator;}
procedure LimitCycles(Which,TimeStep: Integer);
var {TempColor: TColor;}
  TT, T, XSize, YSize { XPos, YPos,}
{NPts,Limit, i, j, Steps}: integer;
  XPosT, YPosT: Longint;
{Xmin, YMin,XMax, YMax,}
  F, D1, D2, D3, X, Y, Z, {TL,TR,BL,BR,} XStep, YStep,
    DL1A, DL1B, DL1, Dl2, Dl3, Dl, Dr, A, B, Step: Extended;
{Ua1, Ua2, Va1, Va2, YTL, YTM, YTR, TM,}
 {C, D, MinU, MaxU, U2, V2, U, V}
begin
    if ((Which = 3)) then
    begin
    If TimeStep mod 3 = 0 then Which :=2 else
    If TimeStep mod 2 = 0 then Which :=1 else Which :=0;
    end;

 { FractalFilename := 'A_LIMIT_000.BMP'; }
  XSize :=1; {(FYImageX div 2);} { physical screen size }
  YSize :=1; {(FYImageY div 2);} { physical screen size }
 { with MainForm.Image2.Canvas do} begin
{Brush.Color:=FBackGroundColor;
Brush.Style:=bsSolid;
FillRect(Rect(0,0,FYImageX,FYImageY));}
    {TempColor := RGB(255 - GetRValue(FBackGroundColor),
      255 - GetGValue(FBackGroundColor),
      255 - GetBValue(FBackGroundColor));
    Pen.Color := TempColor;
    Font.Color := TempColor;}
{MainForm.Show;}
{XMax := 2.67;
XMin := -5.33;
YMax := 4.0;
YMin := -6.67;}
    if ((Which = 0) or (Which = 3)) then begin
      {TextOut(10, 50, 'Rayleigh' ); }
      XStep := (12.8 { XMax - XMin}) / XSize;
      YStep := (9.6 {YMax - YMin}) / YSize;
      Step := 0.1/ 25;
      X := 0; {-1.0;}
      Y := 0; {1.0;}
      F := 1.0; {1.60;}
      Z := 1.0; {MinU := -1E+5;MaxU := 1E+5;}
      for T := 1 to TimeStep{255} do
      begin
      {  MainForm.HiddenFX.Caption := 'HiddenFX Rayleigh';
        Application.ProcessMessages;}
        {TempColor := RGB(Colors[0, T],
          Colors[1, T],
          Colors[2, T]); }
        for TT := 1 to 250 do
        begin
          D1 := Y;
          DL1A := (Y * Y * Y);
          DL1B := (Y - DL1A / 3); //seeems stupid
{If DL1A  < MinU then DL1A := MinU else
If DL1A > MaxU then DL1A := MaxU;
If DL1B  < MinU then DL1B := MinU else
If DL1B > MaxU then DL1B := MaxU;}
          DL := DL1B - X;
{If DL  < MinU then DL := MinU else
If DL > MaxU then DL := MaxU;}
          DR := F * COS(Z);
          D2 := DL + DR;
          D3 := 1;
          X := ((X + D1 * Step));
          Y := ((Y + D2 * Step));
          Z := ((Z + D3 * Step)); {320  240  }

          //XPosT := XSize + round((x / XStep));
          //YPosT := YSize - round((y / YStep));
{     If XPosT > 639 then XposT := 639;
     If XPosT < 1 then XposT := 1;
     If YPosT > 479 then YposT := 479;
     If YPosT < 1 then YposT := 1;
     XPos := XPosT;
     YPos := YPosT;}
{     PutPixel( XPosT, YPosT, Round(Z) );}
          {Pixels[XPosT, YPosT] := TempColor;} {( (T Div 200) + 10 );}
         // If XPosT > YPosT then;
          If XStep > YStep then;
        end; { of For T     NEXT T}
      end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=1;//z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
    end; { of Rayleigh }
(*************************************************************)
(*****************************************************************)
    if ((Which = 1) or (Which = 3)) then begin
     { TextOut(10, 30, 'Van der Pol Oscillator' ); }
{XMax := 2.67;
XMin := -5.33;
YMax := 4.0;
YMin := -6.67;}
      XStep := (12.8 { XMax - XMin}) / XSize;
      YStep := (9.6 { YMax - YMin}) / YSize;
      Step := 0.1 / 25;
      X := 0;
      Y := 0;
 {A := 1.0;}{-0.50; }
      B := 1.0; {0.2;}
{C := 1.0;  }{1.0;}
      F := 0.55; {1.60;}
      Z := 1.0;
{MinU := -1E+5;MaxU := 1E+5;}
      for T := 1 to TimeStep{255} do begin
        {MainForm.HiddenFX.Caption :=
          'HiddenFX Van der Pol Oscillator';
        Application.ProcessMessages;
        TempColor := RGB(Colors[0, T],
          Colors[1, T],
          Colors[2, T]); }
        for TT := 1 to 250 do
        begin
          D1 := Y;
          DL1A := (3 * B);
          DL1B := (X * X);
{If DL1A  < MinU then DL1A := MinU else
If DL1A > MaxU then DL1A := MaxU;
If DL1B  < MinU then DL1B := MinU else
If DL1B > MaxU then DL1B := MaxU;}
          DL1 := (DL1A * DL1B - 1);
          DL2 := (DL1 * Y);
          DL3 := (X + DL2);
          DL := (-1.0 * DL3);
{If DL  < MinU then DL := MinU else
If DL > MaxU then DL := MaxU;}
          DR := F * SIN(1);
          D2 := DL + DR;
          D3 := 1;
          X := ((X + D1 * Step));
          Y := ((Y + D2 * Step));
          Z := ((Z + D3 * Step)); {320  240  }
          XPosT := XSize + round((x / XStep));
          YPosT := YSize - round((y / YStep));
{     If XPosT > 639 then XposT := 639;
     If XPosT < 1 then XposT := 1;
     If YPosT > 479 then YposT := 479;
     If YPosT < 1 then YposT := 1;
     XPos := XPosT;
     YPos := YPosT;}
{     PutPixel( XPosT, YPosT, Round(Z) );}
        {  Pixels[XPosT, YPosT] := TempColor;} {( (T Div 200) + 9 );}
                  If XPosT > YPosT then;
        end; { of For T     NEXT T}
      end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=1;//z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
    end; { of VanderPol }
(*************************************************************)
(*****************************************************************)
{procedure Brusselator;}
    if ((Which = 2) or (Which = 3)) then begin
     { TextOut(10, 10, 'Brusselator' ); }
{XMax := 2.67;
XMin := -5.33;
YMax := 4.0;
YMin := -6.67;}
      XStep := (12.8 {6.4} { XMax - XMin}) / XSize;
      YStep := (9.6 {4.8} { YMax - YMin}) / YSize;
      Step := 0.1 / 25;
      X := 0;
      Y := 0;
      A := 1.0; {-0.50; }
      B := 3.0; {0.2;}
{MinU := -1E+5;MaxU := 1E+5;}
      for T := 1 to TimeStep{255} do begin
        {MainForm.HiddenFX.Caption := 'HiddenFX Brusselator';
        Application.ProcessMessages;
        TempColor := RGB(Colors[0, T],
          Colors[1, T],
          Colors[2, T]);}
        for TT := 1 to 250 do
        begin
          D1 := (X * X * Y);
          DL1A := (A * (B + 1));
          DL1B := 1 - DL1A * X;
{If DL1A  < MinU then DL1A := MinU else
If DL1A > MaxU then DL1A := MaxU;
If DL1B  < MinU then DL1B := MinU else
If DL1B > MaxU then DL1B := MaxU;}
          D2 := DL1B + D1;
          D3 := 3 * X - D1;
          X := ((X + D2 * Step));
          Y := ((Y + D3 * Step)); {320  240  }
          XPosT := XSize + round((x / XStep));
          YPosT := YSize - round((y / YStep));
{     If XPosT > 639 then XposT := 639;
     If XPosT < 1 then XposT := 1;
     If YPosT > 479 then YposT := 479;
     If YPosT < 1 then YposT := 1;
     XPos := XPosT;
     YPos := YPosT;}
        {  Pixels[XPosT, YPosT] := TempColor;} { ((T Div 200) + 8 );}
          If XPosT > YPosT then;
        end; { of For T     NEXT T}
      end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=1;//z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
    end; end;
{  MainForm.HiddenFX.Caption := 'HiddenFX';
  Application.ProcessMessages; }
end; { of Brusselator }
(*************************************************************)
(*************************************************************)



procedure Lorenz(TimeStep: Integer);
const rad_per_degree = 0.0174533;
  third = 0.333333333;
var
  //elapse,
  x, y, z, d0_x, d0_y, d0_z, d1_x, d1_y, d1_z, d2_x, d2_y,
    d2_z,
    d3_x, d3_y, d3_z, xt, yt, zt, dt, dt2
    //, x_angle, y_angle, z_angle
  //  sx, sy, sz, cx, cy, cz, temp_x, temp_y, old_y
    : Extended;
 // SCol: string;
 // ICol, HalfX, HalfY, maxcolx, maxrowy,
 //   dummy, iii, j, row, Scolor, col, old_row, old_col
    iii: integer;
 // ch: char; //TempColor: TColor;
 // Q: array[0..2305] of Extended;
  //Bitmap: TBitmap;
  //PixelLine: PByteArray;
{  function radians_to_degrees(degrees: Extended): Extended;
  begin
    while degrees >= 360 do
      degrees := degrees - 360;
    while degrees < 0 do
      degrees := degrees + 360;
    radians_to_degrees := rad_per_degree * degrees;
  end; }
begin
      x := 0;
      y := 1;
      z := 0;
      dt := 0.01;
      dt2 := dt / 2;
      for iii := 0 to (timestep*10){8000} do
      begin
        d0_x := 10 * (y - x) * dt2;
        d0_y := (-x * z + 28 * x - y) * dt2;
        d0_z := (x * y - 8 * z / 3) * dt2;
        xt := x + d0_x;
        yt := y + d0_y;
        zt := z + d0_z;
        d1_x := (10 * (yt - xt)) * dt2;
        d1_y := (-xt * zt + 28 * xt - yt) * dt2;
        d1_z := (xt * yt - 8 * zt / 3) * dt2;
        xt := x + d1_x;
        yt := y + d1_y;
        zt := z + d1_z;
        d2_x := (10 * (yt - xt)) * dt;
        d2_y := (-xt * zt + 28 * xt - yt) * dt;
        d2_z := (xt * yt - 8 * zt / 3) * dt;
        xt := x + d2_x;
        yt := y + d2_y;
        zt := z + d2_z;
        d3_x := (10 * (yt - xt)) * dt2;
        d3_y := (-xt * zt + 28 * xt - yt) * dt2;
        d3_z := (xt * yt - 8 * zt / 3) * dt2;
        //old_y := y;
        x := x + (d0_x + d1_x + d1_x + d2_x + d3_x) * third;
        y := y + (d0_y + d1_y + d1_y + d2_y + d3_y) * third;
        z := z + (d0_z + d1_z + d1_z + d2_z + d3_z) * third;
       end;
  xr := x*0.5;
  Yr := y*0.5;
  Zr := z*0.5;
  AlphaRF:=AlphaRF-Incremental ;//(255);
//  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
End;
(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)
procedure Strange(TimeStep: Integer); {Vortex}
var
  Xmax, Xmin, Ymax, Ymin, X, Y, Z, deltaX, deltaY,deltaz,
  {   Finder,} max_col, col, max_row, row, zrow,
    Xtemp, Ytemp, {Ztemp,} a, b, c, d, e: Extended;

//j: integer;
  //max_iterations,
  i: longint;
Begin
  max_col :=200;// (FYImageX - 1);
  max_row :=200;// (FYImageY - 1);
 // max_iterations := 50000;
  Xmax := 2.8;
  Xmin := -2.8;
  Ymax := 2.0;
  Ymin := -2.0;
            col :=0;
          row := 0;
          zrow :=0;
  a := 2.24;
  b := 0.43;
  c := -0.65;
  d := -2.43;
  e := 1.0;
  X := 0;
  Y := 0;
  Z := 0;
  deltaX := max_col / (Xmax - Xmin);
  deltaY := max_row / (Ymax - Ymin);
  deltaz := max_row / (Ymax - Ymin);
      for i := 0 to TimeStep{max_iterations} do
      begin
{If Slowdown then Application.ProcessMessages; }
        Xtemp := sin(a * Y) - Z * cos(b * X);
        Ytemp := Z * sin(c * X) - cos(d * Y);
        Z := e * sin(X);
        X := Xtemp;
        Y := Ytemp;
          col := ((X - Xmin) * deltaX);
          row := ((Y - Ymin) * deltaY);
          zrow := ((z - ymin) * deltaz);
      end;
  xr := col*0.1;
  Yr := row*0.1;
  Zr := zrow*0.1;
  AlphaRF:=AlphaRF-Incremental ;//(255);
//  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
End;
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure Duffing(TimeStep: Integer);
var
  A, B, C, F,
    D1, D2, D3,
   // D, MinU, MaxU, U2, V2,  U, V,
    X, Y, Z: Extended;
  //IKan,  NPts, XSize, YSize, Limit, i, j, Steps: integer;
  //XPos, YPos: integer;  XPosT, YPosT: Longint;
  //Xmin, YMin, XStep, YStep, XMax, YMax: Extended;
  TT, T: integer;
  //Ua1, Ua2, Va1, ,  Va2, YTL, YTM, YTR, TM, TL, TR, BL, BR
  DL1A, DL1B, DL1, Dl2, Dl3, Dl, Dr,
    Step: Extended;
begin
 // FractalFilename := 'A_DUFFNG000.BMP';
 // XSize :=200;// FYImageX - 1; { physical screen size }
 // YSize :=200;// FYImageY - 1; { physical screen size }
 (* XMax := 4.0; {3.56}
    XMin := -8.0; {-3.70}
    YMax := 6.0; {6.76   3.61}
    YMin := -10.0; {-5.14  -3.02}
    XStep := (XMax - XMin) / XSize;
    YStep := (YMax - YMin) / YSize;  *)
    Step := 0.1 / 25;
    X := -1.0;
    Y := 1.0;
    A := 1.0; {-0.50; }
    B := 0.3; {0.2;}
    C := 0.0; {1.0;}
    F := 10.0; {1.60;}
    Z := 1.0;
  //  MinU := -1E+5;
  //  MaxU := 1E+5;
    for T := 0 to 25 do begin//255
      for TT := 1 to 25do //250
      begin
        D1 := Y;
        DL1A := (A * X);
        DL1B := (X * X);
{If DL1A  < MinU then DL1A := MinU else
If DL1A > MaxU then DL1A := MaxU;
If DL1B  < MinU then DL1B := MinU else
If DL1B > MaxU then DL1B := MaxU;}
        DL1 := DL1A * DL1B;
        DL2 := (C * X);
        DL3 := (B * Y);
        DL := -(DL1 + DL2 + DL3);
{If DL  < MinU then DL := MinU else
If DL > MaxU then DL := MaxU;}
        DR := F * COS(Z);
        D2 := DL + DR;
        D3 := 1;
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        Z := ((Z + D3 * Step)); {320  240  }
//        XPosT := (XSize div 2) + round((x / XStep));
//        YPosT := (YSize div 2) - round((y / YStep));
//        Pixels[XPosT, YPosT] := TempColor;
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
  xr :=x;
  Yr := y;
  Zr := z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
//  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
  end;{ of Duffing }

(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure Rossler(TimeStep: Integer);
var
{MinU, MaxU, U2,U, V2,} X, Y, Z: Extended;
 // XSize, YSize: integer; { XPos, YPos : integer;}
 // XPosT, YPosT: Longint;
{ZMax,ZMin,  }// Xmin, YMin, XStep, YStep, XMax, YMax: Extended;
  TT, {Colored,,Q} T: integer;
{Ua1, Ua2, Va1, Va2, YTL, YTM, YTR, , N
TM, TL,TR,BL,BR : Extended;}
  Step, A, B, C, D1, D2, D3, D: Extended;
begin
//  XSize :=200; { physical screen size }
//  YSize :=200; { physical screen size }

  //  XMax := 10.0; {11.53}
  //  XMin := -14.0; {-7.07}
  //  YMax := 10.0; {7.85}
  //  YMin := -22.0; {-9}
  {ZMax := 24;   }{23.95}
 {ZMin := 3.0;   }{2.41}
  //  XStep := (XMax - XMin) / XSize;
 //   YStep := (YMax - YMin) / YSize;
    A := 0.2;
    B := 0.2;
    C := 5.7;
    X := 1;
    Y := 1;
    Z := 1;
{T1 = Start, T2 = End time;   D = Delta T (increment time amount }
{ N = number of silent computations }
    D := 0.04;
  //  N := 10.0;
{D := D + D;
Step := Step + Step;}
    Step := D;// / N;
    for T := 0 to 2000 do begin  //2000
      for TT := 1 to 25 do
      begin
        D1 := -Y - Z;
        D2 := X + (Y * A);
        D3 := B + (Z * (X - C));
        X := X + D1 * Step;
        Y := Y + D2 * Step;
        Z := Z + D3 * Step;
      end; { of For T     NEXT T} {320  240  }
    //  XPosT := (XSize div 2) + round((x / XStep));
    //  YPosT := (YSize div 2) - round((y / YStep));
    //  Pixels[XPosT, YPosT] := TempColor;
    end; { of For TT     NEXT TT}
  xr := x;
  Yr := y;
  Zr := z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
//  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
  end;{ of Rossler }
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
   {=======================}
   {       HENON.PAS       }
   {=======================}
procedure Henon_Attractor(TimeStep: Integer);
var
//   {MaxColors, } MaxX, MaxY, XScale, YScale, XOff, YOff: integer;
 // , Color, XPos, YPos
  i: integer;
 {, Xmin, Ymin   Xmax, Ymax,} Xold, Xnew, Yold, Ynew: Extended;
begin
      {         Henon Attractor        }
      {  x := y + 1 - ( 1.4 * x * x )  }
      {  y := 0.3 * x                  }
//  XScale := 1; { values to adjust scale }
//  YScale := 1;
//  XOff := 0; { and screen position    }
//  YOff := 0;
//  Xmin := 0; Ymin := 0;
Xold := 0; Yold := 0;
{   Xmax := 0;Ymax := 0; Xnew := 0; Ynew := 0;}

//    MaxX :=200;// (FYImageX - 1);
//    MaxY :=200;// (FYImageY - 1);

   // for Color := 0 to 15 do begin
      for i := 1 to 100 do { $7FFF } //1000
      begin
        Xnew := Yold + 1 - (1.4 * Xold * Xold);
        Ynew := 0.3 * Xold;
     //   XPos := trunc((XNew * MaxX / 3 * XScale) + MaxX / 2 + XOff);
     //   YPos := trunc((YNew * MaxY * YScale) + MaxY / 2 + YOff);
  xr :=Xnew;// x*0.1;
  Yr :=Ynew;// y*0.1;
  Zr :=1;// z*0.1;

        {if (XPos > Xmin) and (XPos < MaxX) and
          (YPos > Ymin) and (YPos < MaxY) then
        begin Pixels[XPos, YPos] := TempColor; end;}
        Yold := Ynew;
        Xold := Xnew;
      end;
   // end;
  AlphaRF:=AlphaRF-Incremental ;//(255);
//  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of procedure Henon_Attractor; }
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure Kaneko1
  (KanA {01.3}, KanD {0.1}, KanStep {0.01}: Extended;
  DisKan {30}, KanTeen {3000},TimeStep: Integer);
Begin
{}
End;
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure Kaneko2
  (KanA {0.3}, KanD {1.75}, KanStep {0.02}: Extended;
  DisKan {36}, KanTeen {3000},TimeStep: Integer);
Begin
{}
End;
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure Henon2(Target, KamStep {1.2;}: Extended;
                 Incoming {26},TimeStep:  Integer);
{Procedure Henon2;}{Limits 333 Henons Henon Range 1 Henon  >>>>}
Begin
{}
End;
(*************************************************************)
(*************************************************************)



(*************************************************************)
(*************************************************************)
(*************************************************************)
(*************************************************************)
procedure SetChemical(TimeStep: Integer);
Begin
Case TimeStep of
0: StrangeChemicalsa(TimeStep);
1: StrangeChemicalsb(TimeStep);
2:StrangeChemicalsc(TimeStep);
3: StrangeChemicalsd(TimeStep);
4: StrangeChemicalse(TimeStep);
5: StrangeChemicalsf(TimeStep);
else StrangeChemicalsg(TimeStep);
end;
End;
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalsa(TimeStep: Integer);
{dx/dt = -k2x  - k3y(x/k+x) + k1  + k6z
dy/dt = -k2y  - k3x(y/k+x)  + k1  + b
dz/dt = k4y  - k5z}
var
{A,  C, F,} B, k, k1, k2, k3, k4, k5, k6,
    D1, D2, D3,
    D, MinU, MaxU, U2, V2, X, Y, Z, U, V: Extended;
  IKan, NPts, XSize, YSize, Limit, i, j, Steps: integer;
  XPos, YPos: integer;
  XPosT, YPosT,ZPosT,//: Longint;
  Xmin, YMin, XStep, YStep, XMax, YMax: Extended;
  TT, T, Q: integer;
  DL1A, DL1B, DL1, Dl2, Dl3, Dl, Dr,
    Step, Ua1, Ua2, Va1, Va2, YTL, YTM, YTR, TM, TL, TR, BL, BR:
      Extended;
begin
  XSize :=6;//640;// FYImageX - 1; { physical screen size }
  YSize :=6;//480;// FYImageY - 1; { physical screen size }
    XMax := 2.0; {3.56}
    XMin := -1.0; {-3.70}
    YMax := 2.0; {6.76   3.61}
    YMin := -1.0; {-5.14  -3.02}
    XStep := (XMax - XMin) / XSize;
    YStep := (YMax - YMin) / YSize;
    XPosT :=0; yPosT :=0;zPosT :=0;
    Step := 0.1 / 25;
    X := -1.0;
    Y := 1.2;
    Z := 1.0;
    B := 1.0;
    k := 1.0;
    k1 := 1.1;
    k2 := 1.2;
    k3 := 1.3;
    k4 := 1.4;
    k5 := 1.50;
    k6 := 1.70;
{dx/dt = -k2x  - k3y(x/k+x) + k1  + k6z
dy/dt = -k2y  - k3x(y/k+x)  + k1  + b
dz/dt = k4y  - k5z}
    MinU := -1E+5;
    MaxU := 1E+5;
    for T := 1 to TimeStep{255} do
    begin
      for TT := 1 to 20 do
      begin
        DL1 := (-k2 * X);
        DL1A := X;
        DL1B := (X / k);
        DL2 := (DL1A + DL1B);
        DL3 := (k3 * y);
        DL := (DL1 - (DL2 * DL3));
        DR := (k1 + (k6 * Z));
        D1 := DL + DR;
{dx/dt = -k2x  - k3y(x/k+x) + k1  + k6z
dy/dt = -k2y  - k3x(y/k+x)  + k1  + b
dz/dt = k4y  - k5z}
        DL1 := (-k2 * Y);
        DL1A := X;
        DL1B := (Y / k);
        DL2 := (DL1A + DL1B);
        DL3 := (k3 * X);
        DL := (DL1 - (DL2 * DL3));
        DR := (k1 + (B));
        D2 := DL + DR;
        D3 := (k4 * Y) - (k5 * z);
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        Z := ((Z + D3 * Step)); {320  240  }
        XPosT := //(XSize div 2) + round((x / XStep));
        (x / XStep);
        YPosT := //(YSize div 2) - round((y / YStep));
        (y / YStep);
        zPosT := (z / YStep);
        //Pixels[XPosT, YPosT] := TempColor;
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=xPosT;
          Yr :=yPosT;
          Zr :=zPosT;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicalsA }
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalsb(TimeStep: Integer);
{dx/dt = k1  + k2'x  - ((k3y = k4z)x / (x+k))
dy/dt = k5x  - k6y
dz/dt = k7x  - k8'z / (z+k')}
var
{A,  C, F, B,} k, k1, k2, k3, k4, k5, k6, k7, k8,
    D1, D2, D3,
 //, U, V   D, MinU, MaxU,     U2, V2,
    X, Y, Z: Extended;
//XSize, YSize, , Q    IKan, NPts,  Limit,  i, j, Steps: integer;
 // XPos, YPos: integer;    XPosT, YPosT: Longint;
 // Xmin, YMin, XStep, YStep, XMax, YMax: Extended;
  TT, T: integer;
//    Ua1, Ua2, Va1, Va2,
 //    YTL, YTM, YTR, TM, TL, TR, BL, BR:
  DL1A, DL1B, DL1, Dl2, Dl3, Dl, Dr,Step
      :Extended;
begin
(*  FractalFilename := 'A_ST_CB0.BMP';
  XSize := FYImageX - 1; { physical screen size }
  YSize := FYImageY - 1; { physical screen size }
    XMax := 42.0; {3.56}
    XMin := 32.0; {-3.70}
    YMax := 42.0; {6.76   3.61}
    YMin := 32.0; {-5.14  -3.02}
    XStep := (XMax - XMin) / XSize;
    YStep := (YMax - YMin) / YSize; *)
    Step := 0.1 / 25;
    X := 1.1;
    Y := 1.1;
    Z := 0.510;
//    B := 1.10;
    k := 1.0;
    k1 := 1.1;
    k2 := 1.2;
    k3 := 1.3;
    k4 := 1.1;
    k5 := 1.15;
    k6 := 1.0;
    k7 := 1.0;
    k8 := 1.0;
{dx/dt = k1  + k2'x  - ((k3y + k4z)x / (x+k))
dy/dt = k5x  - k6y
dz/dt = k7x  - k8'z / (z+k')}
//    MinU := -1E+5;
//    MaxU := 1E+5;
    for T := 1 to 255 do begin
      for TT := 1 to 200 do
      begin
        DL1 := ((k2 * X));
        DL := (k1 + DL1);
        DL1A := (k3 * Y);
        DL1B := (k4 * Z);
        DL2 := ((DL1A + DL1B) * X);
        DL3 := (X + k);
        DR := (DL2 / DL3);
        D1 := DL - DR;
{dx/dt = k1  + k2'x  - ((k3y + k4z)x  / (x+k))
dy/dt = k5x  - k6y
dz/dt = k7x  - k8'z / (z+k')}
        DL := (k5 * X);
        DR := (k6 * Y);
        D2 := (DL - DR);
        DL1 := (k7 * X);
        DL1A := (k8 * Z);
        DL1B := (DL1 - DL1A); {Math correct?}
        DL2 := (Z + k);
        D3 := (DL1B / DL2);
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        Z := ((Z + D3 * Step)); {320  240  }
       // XPosT := (XSize div 2) + round((x / XStep));
       // YPosT := (YSize div 2) - round((y / YStep));
       // Pixels[XPosT, YPosT] := TempColor;
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicalsB }
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalsc(TimeStep: Integer);
{dx/dt = -y - z - w
dy/dt = x
dz/dt = c(z/2  - z^2)  -dw}
var
{s : string[10];}
{A,  F,B, k, k1,k2,k3,k4,k5,k6,k7,k8,}
  D1, D2, D3, C, w, D,
 {MinU, MaxU, U2, V2,} X, Y, Z {, U, V}: Extended;
{IKan, NPts,}
  {HalfY, HalfX, XSize, YSize , Limit, i, j, Steps: integer;}
{ XPos, YPos : integer;
  XPosT, YPosT: Longint;
  Xmin, YMin, XStep, YStep, XMax, YMax: Extended;}
  TT, T {,Q}: integer;
  DL1A, DL1B, DL1, Dl2, {Dl3, Dl, Dr,}
    Step:Extended;
begin
    Step := 0.1 / 25;
    X := 0.12;
    Y := 0.00012;
    Z := 0.00211;
    C := 0.00120;
    w := 0.110;
    D := 0.21;
{dx/dt = -y - z - w
dy/dt = x
dz/dt = c(z/2  - z^2)  -dw}
    for T := 1 to 255 do begin
      for TT := 1 to 235 do
      begin
        D1 := ((-y) - (z - w));
{dx/dt = -y - z - w
dy/dt = x
dz/dt = c(z/2  - z^2)  -dw}
        D2 := (X);
        DL1 := (Z / 2);
        DL1A := (Z * Z);
        DL1B := (c * (DL1 - DL1A));
        DL2 := (d * w);
        D3 := (DL1B - DL2);
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        Z := ((Z + D3 * Step)); {320  240  }
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicalsC }
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalsd(TimeStep: Integer);
{dx/dt = V1  - b1x  - V
dy/dt = V2 - b2y  + V  -(m(y-z))
dz/dt = ma(y-z)
V = (x - ky) / (1 + (x+y)(1 + cx^g) )}
var
  C, g, V, V1, V2, b1, k, m, a, b2,
  D1, D2, D3, X, Y, Z: Extended;
  TT, T {,Q}: integer;
  DL1A, DL1B, DL1, Dl2, Dl3, Dl, Dr,Step :  Extended;

begin
    Step := 0.1 / 25;
    X := 12.2;
    Y := 12.0;
    Z := 12.1;
    V := 1.1;
    V1 := 02.20;
    V2 := 02.10;
    b1 := 1.20;
    b2 := 1.30;
    m := 1.20;
    a := 1.30;
    k := 1.20;
    g := 1.10;
    C := 1.10;
{dx/dt = V1  - b1x  - V
dy/dt = V2 - b2y  + V  -(m(y-z))
dz/dt = ma(y-z)
V = (x - ky) / (1 + (x+y)(1 + cx^g) )}
    for T := 1 to 255 do begin
      for TT := 1 to 200 do
      begin
        DL1 := (b1 * X);
        D1 := (V1 - DL1 - V);
{dx/dt = V1  - b1x  - V
dy/dt = V2 - b2y  + V  -(m(y-z))
dz/dt = ma(y-z)
V = (x - ky) / (1 + (x+y)(1 + cx^g) )}
        DL1 := (b2 * y);
        DL1A := (V2 - DL1 + V);
        Dl3 := (y - z);
        Dr := (m * Dl3);
        D2 := (DL1A - Dr);
        DL1A := (m * a);
        D3 := (DL1A * Dl3);
        DL1A := (k * y);
        DL1 := (X - DL1A);
        DL1A := power(x, g);
        DL1B := (c * (DL1A));
        DL2 := (1 + DL1B);
        Dl := (X + Y);
        Dr := (DL2 * Dl);
        Dl3 := (1 + Dr);
        V := (DL1 / Dl3);
{V = (x - ky) / (1 + (x+y)(1 + cx^g) )}
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        Z := ((Z + D3 * Step)); {320  240  }
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicals D }
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalse(TimeStep: Integer);
{dx/dt = x(a1  - k1x  - z  -y)  + k2y^2  + a3
dy/dt = y(x - k2y - a5)  + a2
dz/dt = z(a4  - x  - k5z)  + a3}
var
  k5, k1, k2, a1, a2, a3, a4, a5,
  D1, D2, D3, X, Y, Z: Extended;
  TT, T {,Q}: integer;// Dl2,
  DL1A, DL1B, DL1, Dl3, Dl, Dr,  Step : Extended;
begin
    Step := 0.1 / 25;
    X := 12.2;
    Y := 12.0;
    Z := 12.1;
    k5 := 1.1;
    k1 := 02.20;
    k2 := 02.10;
    a1 := 1.20;
    a2 := 1.30;
    a3 := 1.20;
    a4 := 1.30;
    a5 := 1.20;

{dx/dt = x(a1  - k1x  - z  -y)  + k2y^2  + a3
dy/dt = y(x - k2y - a5)  + a2
dz/dt = z(a4  - x  - k5z)  + a3}
    for T := 1 to 255 do begin
      for TT := 1 to 200 do
      begin
        DL1 := (k1 * X);
        DL1A := (a1 - DL1 - z - y);
        DL1B := (x * (DL1A));
        Dl := (Y * Y);
        Dr := (k2 * Dl);
        D1 := (Dr + Dl1B + a3);
{dx/dt = x(a1  - k1x  - z  -y)  + k2y^2  + a3
dy/dt = y(x - k2y - a5)  + a2
dz/dt = z(a4  - x  - k5z)  + a3}
        DL1 := (k2 * y);
        DL1A := (x - DL1 - a5);
        Dl3 := (y * DL1A);
        D2 := (DL3 + a2);
        DL1 := (k5 * z);
        DL1A := (a4 - x - DL1);
        Dl3 := (z * DL1A);
        D3 := (DL3 + a3);
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        Z := ((Z + D3 * Step)); {320  240  }
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicals e }
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalsf(TimeStep: Integer);
{dx/dt = V0  - b1x  - V
dy/dt = 1 - y - V
V =  (ay) / ( (1+ dy) (c+ x(1 + x^g)) )}
var
{A,  F,B, k, k1,k2,k3,k4,k5,k6,k7,k8,}
  C, g, V, V0, b1, a, d,
  D1, D2, D3, X, Y, Z: Extended;
  TT, T {,Q}: integer;
  DL1A, DL1B, DL1, Dl2, Dl3, Dl, Dr,
    Step : Extended;
begin
    Step := 0.1 / 25;
    X := 12.2;
    Y := 12.0;
    Z := 12.1;
    V := 21.1;
    V0 := 02.20;
    b1 := 1.20;
    C := 1.20;
    a := 1.30;
    d := 11.20;
    g := 11.10;
{dx/dt = V0  - b1x  - V
dy/dt = 1 - y - V
V =  (a x y) / ( (1+ dy) (c+ x(1 + x^g)) )}
    for T := 1 to 255 do begin
      for TT := 1 to 200 do
      begin
        DL1 := (b1 * X);
        D1 := (V0 - DL1 - V);
{dx/dt = V0  - b1x  - V
dy/dt = 1 - y - V
V =  (a x y) / ( (1+ dy) (c+ x(1 + x^g)) )}
        D2 := (1 - y - V);
        DL1 := (a * x * y);
        DL1A := power(x, g);
        DL1B := (x * (1 + DL1A));
        DL2 := (C + DL1B);
        Dl := (d * Y);
        Dr := (1 + Dl);
        Dl3 := (Dl2 * Dr);
        V := (DL1 / Dl3);
{V = (x - ky) / (1 + (x+y)(1 + cx^g) )}
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
        D3:=V;
  Z := ((Z + D3 * Step)); {320  240  }
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicals  }
(*************************************************************)
(*************************************************************)
procedure StrangeChemicalsg(TimeStep: Integer);
{Rietman p111}
{dx/dt = k1A - k2Bx + k3x^2y  - k4x
dy/dt = k2Bx  - k3 x^2y}
var k1, k2, k3, k4, B, A,
 //Dl,D3, Dr,
    D1, D2,  X, Y, Z: Extended;
  TT, T {,Q}: integer;
  DL1A, DL1B, DL1, Dl2, Dl3,  Step: Extended;
begin
    Step := 0.1 / 25;
    X := 1.2;
    Y := 1.0;
   // Z := 1.1;
    k1 := 1.1;
    k2 := 01.20;
    k3 := 01.10;
    k4 := 1.20;
    B := 1.20;
    A := 1.30;
{dx/dt = k1A - k2Bx + k3x^2y  - k4x
dy/dt = k2Bx  - k3 x^2y}
    for T := 0 to 255 do begin
      for TT := 1 to 200 do
      begin
{dx/dt = k1A - k2Bx + k3x^2y  - k4x
dy/dt = k2Bx  - k3 x^2y}
        DL1 := (k1 * A);
        DL1A := (k2 * B * X);
        DL1B := (X * X);
        DL2 := (k3 * DL1B * Y);
        Dl3 := (k4 * X);
        D1 := (DL1 - DL1A + DL2 - Dl3);
        DL1A := (k2 * B * X);
        DL1B := (X * X);
        DL1 := (k3 * DL1B);
        D2 := (DL1A - DL1);
        X := ((X + D1 * Step));
        Y := ((Y + D2 * Step));
Z :=1;// ((Z + D3 * Step));    {320  240  }
      end; { of For T     NEXT T}
    end; { of For TT     NEXT TT}
          xr :=x;
          Yr :=y;
          Zr :=z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of StrangeChemicals g }
(*************************************************************)
(*************************************************************)

end.
