{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmGlsTrealProgressFormUnit;

interface

uses
  Windows, Messages, SysUtils,  Classes,
  Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TdtmGlsTrealProgressForm = class(TForm)
    ProgressBar: TProgressBar;
    CancelButton: TButton;
    procedure CancelButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var dtmGlsTrealProgressForm: TdtmGlsTrealProgressForm;

implementation

uses TreeConstants;

{$R *.dfm}

procedure TdtmGlsTrealProgressForm.CancelButtonClick(Sender: TObject);
begin
  if MessageDlg('Are you sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    GlsUserCancelled := True;
end;

procedure TdtmGlsTrealProgressForm.FormShow(Sender: TObject);
begin
  GlsUserCancelled := False;
end;

end.
