{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{ A Progress Bar for those that have no space or form   }
{*******************************************************}
unit dtmProgressFrm;

interface

uses
  Windows, Classes,
  Shellapi,{ShellExecute}
  Forms,   {App}
  Dialogs,  {MessageDlg}
  Sysutils, {Filestuff}
  Messages, Graphics, Controls, ComCtrls;


type
  TdtmProgressForm = class(TForm)
    ProgressBar1: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dtmProgressForm: TdtmProgressForm;

implementation

{$R *.DFM}

uses {dtmErrMsg, dtmGlobals,} dtmPOFvar;

procedure TdtmProgressForm.FormCreate(Sender: TObject);
begin
  top := MessageY;
  left := MessageX;
end;

procedure TdtmProgressForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MessageY := dtmProgressForm.top;
  MessageX := dtmProgressForm.left;
end;

end.
