unit AllShapeLoaderFrm;
{ ShapeLoaderForm.Show;
  ShapeLoaderForm.SaveShpFile(CurrentLayer,FileName);
  ShapeLoaderForm.Hide;  }
(*    ShpType: Integer;
      x1 Points, x3 Arc (Lines), x5 Polygon, x8 MultiPoint
      {1,3,(4 is Lines and Areas for conversion)5,8,(#9)
       11,13,15,18, (Measured 3D)
       21,23,25,28, (Measured 2D)
      (31),
      32, Mesh TIN
      (33)
      34, Fan
      (35)
      36, Strip
      37, OI polys -> 1 + ?n  Outer + Inner ?n
      (38)
      39, Rings -> Ring1 + Rings ?n   else is a 15}*)
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Dbf, Db, DBTables;

type
  FieldDefRec= record
    FieldNo: Integer;
    Displayname:String;
    DataType: TFieldType;
    Size: Integer;
    Precision: Integer;
    Required: Boolean;
    {TFieldDef Field Name,Type,Size for Each attribute}
   end;

  Pnts = record
    Xd,Yd: Double;
   end;
  Pnts3 = record
    Xd,Yd,Zd,Md: Double;
   end;
  PAR = record
    PA:array of Pnts;  {Pnts in each Part}
   end;
  PAR3 = record
    PA3:array of Pnts3;{Pnts in each Part}
   end;
  ShpObj = record
    ShpType: Integer;{Shape type for THIS Object: ONLY MY Types}
    ShapeIDN, {Shape Object number in file}
    PntsN, {Total points in Object}
    PartsN:integer;{1 implies single part with no subpparts}
    PPA: array of Integer;{# of Pnts in each Part}
    PARA: array of PAR;{array of Pnts for each Part in Object}
    {Boundary of THIS object}
    XMin,YMin,XMax,YMax{,ZMin,MMin,ZMax,MMax}: Double;
    {array of the attributes AS Strings .. per Object}
    AAttributes:array of string;{0..AttributesN-1}
  end;
    {all per ShpObj: PARA[PartsN #].PA[PPA[PartsN #]].Xn }
  ShpObj3 = record
    ShpType: Integer;{Shape type for THIS Object: ONLY MY Types}
    ShapeIDN, {Shape Object number in file}
    PntsN, {Total points in Object}
    PartsN:integer;{1 implies single part with no subpparts}
    PPA: array of Integer;{# of Pnts in each Part}
    PARA3: array of PAR3;{array of Pnts for each Part in Object}
    {Boundary of THIS object}
    XMin,YMin,XMax,YMax,ZMin,MMin,ZMax,MMax: Double;
    {array of the attributes AS Strings .. per Object}
    AAttributes:array of string;{0..AttributesN-1}
  end;

  ShpLayer = record{Shape Type and Boundary}
    LayerN,{Layer number loaded as}
    ShapeN,{Number of Shape Objects in file layer}
    IslandsN,{Total Islands  ie. ShapeN+IslandsN=Total parts}
    TotalPnts:Integer;{Total Points in file layer}
    Modified:Boolean; {Editing done for THIS layer}
    ShpType: Integer;{Shape file type for THIS Layer:
                       All except MY Types}
    LayerDBName,LayerDBPath,{ ? should be same as Shape file name..}
    Filename,Path:String;
    OffsetX, OffsetY,{Offset +- resets-sizes to 0,0 for display}
      {Boundary of Layer}
    XMin,YMin,XMax,YMax,ZMin,MMin,ZMax,MMax: Double;
       {Attribute count for THIS File}
    AttributesN: Integer;
      {TFieldDef Field Name,Type,Size for Each attribute}
    AttType:array of FieldDefRec;
      {All the Objects in the file}
    LyrShp:array of ShpObj;
    {LayA[].LyrShp[].PARA[PartsN #].PA[PPA[PartsN #]].Xn Yn Zn Mn}
    LyrShp3:array of ShpObj3;
    {LayA[].LyrShp[].PARA[PartsN #].PA[PPA[PartsN #]].Xn Yn Zn Mn}
    LayerColor:TColor;
    {GR32 data}
    CanvasLineSize,
    PointSize,CurrentPointType:Integer;
    StippleColorCount:Integer;
    UseStippleStep:Boolean;
    StippleStep:Single;
    StippleColorArray:array of TColor;
    OutLineColor:TColor;
    PolyFillType:Integer; PolyFillFile:String;
    PolyFilled,
    UseOutlinePoly, PolygonAntialiased:Boolean;
    FillAlphaPosition, LineAlphaPosition:Integer;
    LineSize:Single;
    OtsNameEditText:String;{Actor Name}
  end;
(*  ShpLayer3 = record{Shape Type and Boundary}
    LayerN,{Layer number loaded as}
    ShapeN,{Number of Shape Objects in file layer}
    IslandsN,{Total Islands  ie. ShapeN+IslandsN=Total parts}
    TotalPnts:Integer;{Total Points in file layer}
    Modified:Boolean; {Editing done for THIS layer}
    ShpType: Integer;{Shape file type for THIS Layer:
                       All except MY Types}
    LayerDBName,LayerDBPath,{ ? should be same as Shape file name..}
    Filename,Path:String;
    OffsetX, OffsetY,{Offset +- resets-sizes to 0,0 for display}
      {Boundary of Layer}
    XMin,YMin,XMax,YMax,ZMin,MMin,ZMax,MMax: Double;
       {Attribute count for THIS File}
    AttributesN: Integer;
      {TFieldDef Field Name,Type,Size for Each attribute}
    AttType:array of FieldDefRec;
      {All the Objects in the file}
    LyrShp3:array of ShpObj3;
    {LayA[].LyrShp[].PARA[PartsN #].PA[PPA[PartsN #]].Xn Yn Zn Mn}
    LayerColor:TColor;
  end;    *)

  SymObj = record
  {0 Not, 1 Simple, 2 Unique, 3 Classed, 4 Individual}
    SymSymboled, SymLabeled, SymClassSize:Integer;
    SymStyle,SymLineStyle,SymLineWidth:Integer;
    SymLabelBackColor, SymLineColor, SymBrushColor:TColor;
    isSymOutlined, isSymLabelSet,isSymLabelColored:Boolean;
    SymFont:Tfont;
    SymObjlabelFieldstring: string;
    labelHeight,labelAngle,HAlign,VAlign:Integer;
    LabelX,LabelY:Double;
    end;
  SymLayer=record
    SymLayerBeginSize,SymLayerEndSize, SymLayerClasses,
   {0 Not, 1 Simple, 2 Unique, 3 Classed, 4 Individual}
    SymLayerSymboled, SymLayerLabeled:Integer;
    SymLayerStyle, SymLayerLineStyle,
    SymLayerLineWidth{1.. else no style}:Integer;
    SymLayerLabelBackColor,
    SymLayerStartColor, SymLayerFinishColor,
    SymLayerLineColor,  SymLayerBrushColor:TColor;
    isSymLayerEditable,
    isSymLayerOutlined, isSymLayerLabelColored:Boolean;
    SymFont:Tfont;
    labelHeight,labelAngle,Field:Integer;
    SymLayerClassBreaks:Array of Double;
    SymLayerlabelFieldstring: array of string;
    LyrSym:array of SymObj;{Store data for EACH OBJECT  LayA[].ShapeN}
  end;

{sSinData
BlockRead(outfile,ProjData , Sizeof(ProjData), NumRead);
TempInteger:=ProjData;
PixelsPerDegreeEdit.Text:=InttoStr(TempInteger);
      BlockRead(outfile,sSinData , Sizeof(sSinData), NumRead);
  KiloPerPixelEdit.Text:=FloattoStr(sSinData);


ProjData:=StrtoInt(PixelsPerDegreeEdit.Text);
      Blockwrite(outfile,ProjData , Sizeof(ProjData), NumRead);
  sSinData:=StrtoFloat(KiloPerPixelEdit.Text);
      Blockwrite(outfile,sSinData , Sizeof(sSinData), NumRead);
  }

  Type
  ProjRec=Record
  SourceCBItemindex,VersionEditText,
  ValidProjectionCBChecked,
  IntegerorFloatCBChecked,
  MapZUnitsCBItemindex,PixelCoordinateCBItemindex,
  ProjectionCBItemindex,InUnitCBItemindex,
  InUtmZoneCBItemindex,UTMZoneNorthCBChecked,
  InDatumCBItemindex,  SpheroidCBItemindex:Byte;
  PixelsPerDegreeEdit,
    SEXEWEditText,SEYNSEditText,
    StatePlaneZoneEditText,NullValueEditText  :Smallint;
    CountryFipsCodeCBItemIndex,
    StateFipsCodeCBItemIndex,
    CountyFipsCodeCBItemIndex,
  XWidthEditText,YHeightEditText  : Integer;
  KiloPerPixelEdit:Single;
  PixelXSizeEditText,PixelYSizeEditText,ZSizeEditText,
  TopLeftXEditText,TopLeftYEditText,
  TopRightXEditText,TopRightYEditText,
  BottomLeftXEditText,BottomLeftYEditText,
  BottomRightXEditText,BottomRightYEditText,
    DLGPA1Text,DLGPA2Text,DLGPA3Text,
    DLGPB1Text,DLGPB2Text,DLGPB3Text,
    DLGPC1Text,DLGPC2Text,DLGPC3Text,
    DLGPD1Text,DLGPD2Text,DLGPD3Text,
    DLGPE1Text,DLGPE2Text,DLGPE3Text
  :Double;
  CellLocatorEditText:String[8];
  end;
  var
  MapProjRec: ProjRec;
{Store Info for Each Layer loaded as MapLayerRec}
  Type
  MapRec=Record
    MapNameEdit,       MapDateEdit,       MapRevisionEdit,
    MapScaleEdit,      MapQuadrangleEdit, ProductTypeEdit,
    PreProcessingEdit, ResamplingTechniqueEdit
    :string[255];{ :String;}

    MapEdge1Edit, MapEdge2Edit, MapEdge3Edit, MapEdge4Edit,
    MapEdgeW1Edit,MapEdgeW2Edit,
    MapEdgeN1Edit,MapEdgeN2Edit,
    MapEdgeE1Edit,MapEdgeE2Edit,
    MapEdgeS1Edit,MapEdgeS2Edit:Char;

    bIsProjectedCB, bNeverProjectedCB,
    bIgnoreDatumCB, bIgnoreErrorsCB,
    bUTMZoneNorthCB,
    bProjectionValidCBox:Boolean;

    CatNameCB,
    ProjectionCB,
    InUnitCB,
    InUtmZoneCB,
    InDatumCB,
    SpheroidCB,
    StatePlaneZoneEdit:Integer;

    ModeEdit,
    SMajorEdit, SMinorEdit,    SphereEdit,
    FEEdit,     FNEdit,        OriginLatEdit,
    STDPR1Edit, STDPR2Edit,    CentMerEdit,
    TrueScaleEdit,    CentLonEdit,    CenterLatEdit,
    STDPAREdit, LongPolEdit, FactorEdit, HeightEdit,
    ShapeMEdit, ShapeNEdit,  AngleEdit,
    Long1Edit,  Long2Edit,   Lat1Edit,   Lat2Edit,
    AziAngEdit, AzmthPtEdit, IncAngEdit,
    AscLongEdit,PSRevEdit,   LRatEdit,
    PFlagEdit,  SatnumEdit,  PathEdit:Double;
    DLGPA1,DLGPA2,DLGPA3,
    DLGPB1,DLGPB2,DLGPB3,
    DLGPC1,DLGPC2,DLGPC3,
    DLGPD1,DLGPD2,DLGPD3,
    DLGPE1,DLGPE2,DLGPE3,
    DLGPP1,DLGPP2,DLGPP3,DLGPP4:Double;

    MapZUnitsCB, MapMUnitsCB:Integer;

    MapXMaxEdit,MapXMinEdit,
    MapYMaxEdit,MapYMinEdit,
    MapZMaxEdit,MapZMinEdit,
    MapMMaxEdit,MapMMinEdit:Double;

    bCoordinatesValidCBox:Boolean;

    ULLongitudeEdit,ULLatitudeEdit,
    URLongitudeEdit, URLatitudeEdit,
    LLLongitudeEdit,LLLatitudeEdit,
    LRLongitudeEdit,LRLatitudeEdit:Double;

    MetadataFileEdit:string[255];{ :String;}
  end;
  MapLayerFile = file of MapRec;{for Layer Projections}

  Type
  LegendRec=Record
  ProjectionName:String;

  ProjectionCB,  GridsRG,
  TitleTopCount,AuthorTopCount,TitleBottomCount,AuthorBottomCount,
  SourceCount,FeatureTextCount,NorthArrowTextCount,
  ContourIntervalCount:Integer;

  TitleTopFont, AuthorTopFont,TitleBottomFont,
  AuthorBottomFont,SourceFont,FeatureTextFont,
  NorthArrowTextFont,ContourIntervalFont:Tfont;

  TitleTop,AuthorTop,TitleBottom,AuthorBottom,
  Source,FeatureText,NorthArrowText,ContourInterval:array of string;

  TitleTopOn,AuthorTopOn,TitleBottomOn,AuthorBottomOn,
  SourceOn,FeatureTextOn,NorthArrowTextOn,
  ContourIntervalOn:Boolean;

  TitleTopAt,AuthorTopAt,TitleBottomAt,AuthorBottomAt,
  SourceAt,FeatureTextAt,NorthArrowTextAt,
  ContourIntervalAt:Array[0..7] of Integer;
  {BITMAPS}
  MapLocationText,
  GridName,NorthArrowBitName,LegendName,
  MapLocationName,ScalebarsName,FeatureBitmapName:String;

  GridOn,NorthArrowBitOn,LegendOn,
  MapLocationOn,ScalebarsOn,FeatureBitmapOn:Boolean;

  PaperSizeAt, NorthArrowBitAt,LegendAt,MapAt,
  MapLocationAt,ScalebarsAt,FeatureBitmapAt:Array[0..7] of Integer;
  end;


var
  MapLegendRec: LegendRec;{Loaded with Map Project file}
  MapProject: MapRec;  { "   "  }
  MapLayerRec: MapRec;{Loaded and saved per command per layer}

  MapVersion:Double;{Map load and save}
  {Length is 0..LayersLoaded-1 to use with Index es}
  LayersControlArray: Array  of Integer;
  ShapesFoundArray: Array of array[1..2]of Integer;
  ShpFilename: string;
  {Extents used in Drawing.. ? always positive?}
  MaxOffsetX, MaxOffsetY,{Offset is +- to center data to 0,0}
  MaxExtentX, MaxExtentY,{Store difference : MinOffX, MaxOffX}
  MinOffX, MaxOffX, MinOffY, MaxOffY:Double; {resize view data}

  dXMIN, dXMAX, dYMIN, dYMAX:Double;


  CurrentObj, {selected when searching else 0}
  CurrentObjPart,
  CurrentObjPoint,
  CurrentField, {selected from FieldComboBox}

  AnnoLayerCreatedAs,PolygonLayerCreatedAs,
  LineLayerCreatedAs,   PointLayerCreatedAs,
  SearchDbField,
  ShapesFound,
  CurrentLayer,{selected from LayerComboBox or LayerCount when loaded}
   LayersLoaded{0 is nil for editing}:Integer;
  IsMapLoaded, IsProjected, IsPointDrawn,
  AnnoLayerCreated,   PolygonLayerCreated,
  LineLayerCreated,   PointLayerCreated,
  isShapeSelected,
  bDemLoaded, bBackClipBitmapLoaded:Boolean;
    DemPath, DemName,
    BackBitmapPath, BackBitmapName,
  NewLayerName:String;

  MapA:Array of SymLayer;{  MapA[].LyrSym[]  MapA[].Labeled}
  LayA:array of ShpLayer;{All Shape Layers for all Files loaded}
  {LayA[].LyrShp[].PARA[].PA[].Xn   Yn Zn Mn}
  AnnoA: array of SymObj;
var  LayDatabase: array of TDatabase;
  LayerDBCount:Integer;

type
  TShapeLoaderForm = class(TForm)
    ProgressBar: TProgressBar;
    HintsLabel: TLabel;
    Table1TTable: TTable;
    Dbf1: TDbf;
    Table1: TDbf;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
procedure SaveShpFile(LayerToSave:Integer;FileName:String);
procedure SaveShpDXFFile(LayerToSave:Integer;FileName:String);
procedure SaveShpDatFile(LayerToSave:Integer;FileName:String);


Function LoadDatabase(WhichLayer:Integer):Boolean;
Function SaveDatabase(WhichLayer:Integer):Boolean;
function RunTimeDbCreate(
  const DatabaseName, InPath,  SessionName: string): TDatabase;

Function LoadLayer:Boolean;
procedure WriteShapeAttFile(FileName:String;Which:Integer);
procedure ReadShapeAttFile(FileName:String;Which:Integer);
procedure SetDisplayStyle(LayerToDo:Integer);
Function SetMyColor(InColor:Integer):TColor;
Function LoadHeightBase(FileName:String):Boolean;
  end;

var
  ShapeLoaderForm: TShapeLoaderForm;


implementation

{$R *.DFM}


procedure TShapeLoaderForm.FormCreate(Sender: TObject);
begin
  LayerDBCount := 0;
end;

{  AllShapeLoaderFrm   ShapeLoaderForm.  }
procedure TShapeLoaderForm.SaveShpFile(LayerToSave:Integer;FileName:String);
var
  IndexFileOut, ShapeFileOut: file;
  temp: string;
  ShapeByte: Byte;
  Incrementer, IndexOffsetTotal,
  PartCount,PartCounter,
  PointCount,PointCounter, PartCountTotal,
  Count, Shapetype, ShapeInteger: Integer;
  ShapeFileSize, IndexFileSize,
  RecordSize,  IndexOffset  : integer;
procedure SwapShapeInteger(Incoming: Integer);
  var ByteArray: array[0..3] of Byte;
begin
    Move(Incoming, ByteArray, 4);
    ShapeByte := ByteArray[3];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[2];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[1];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[0];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
end;
procedure SwapIndexInteger(Incoming: Integer);
  var ByteArray: array[0..3] of Byte;
begin
    Move(Incoming, ByteArray, 4);
    ShapeByte := ByteArray[3];
    BlockWrite(IndexFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[2];
    BlockWrite(IndexFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[1];
    BlockWrite(IndexFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[0];
    BlockWrite(IndexFileOut, ShapeByte, 1);
end;

Begin
  {Write the Layer to a Shape file
   .shp  .shx  .dbf .sbx is an index to another .db}
  ShapeLoaderForm.Show;
     {Set up Shape and Index file}
  temp := ChangeFileExt(FileName, '.shx');
  AssignFile(IndexFileOut, temp);
  Rewrite(IndexFileOut, 1);
  AssignFile(ShapeFileOut, FileName);
  Rewrite(ShapeFileOut, 1);
  ProgressBar.Position:=0;
  Application.ProcessMessages;
  SwapShapeInteger(9994);
  SwapIndexInteger(9994);
  for Incrementer := 1 to 5 do
  begin {5 blank zeros}
    SwapShapeInteger(0);
    SwapIndexInteger(0);
  end;

  {Compute and Write File size}
  Shapetype:=LayA[LayerToSave].ShpType;
  ShapeFileSize:=1;
  IndexFileSize:=1;
  Case Shapetype of
  1:Begin     {14= 4+ 2 + 8}
     ShapeFileSize := ((LayA[LayerToSave].ShapeN * (10+4)) + 50);
     IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
      {(Each point set is a header, shape type,and the 2 points)
        + Main header, in 16 bit words - not bytes}
    end;
  3..5:
    begin
      {Lines} {8 for X and Y points}
      {count the number of Polylines per line,
        ...like islands in area}
            {28=22 +2(1 part)+4 (header)}
      ShapeFileSize :=
            ((LayA[LayerToSave].ShapeN * 28)
          {They ALL have 1 line, some have more,
           so count islands (line) separate}
            + (LayA[LayerToSave].IslandsN * 2) {Islands pointers }
            + (LayA[LayerToSave].TotalPnts * 8)
            + 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
         {as 16 bit words, not 8 bit bytes}
          {(Each line set is a header,
            count stuff and the points) + Main header}
    end;
  8:  {MultiPoint}
    Begin                                      {20+4}
      ShapeFileSize := ((LayA[LayerToSave].ShapeN * 24)
                            + (LayA[LayerToSave].TotalPnts * 8)
                            + 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    End;
  11:  {Point Z}
    Begin
      ShapeFileSize := ((LayA[LayerToSave].ShapeN * (10+8+4))+ 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    End;
  13..15:
    begin
      ShapeFileSize :=      {Mand Z Min Max}
            ((LayA[LayerToSave].ShapeN * (28+8))
            + (LayA[LayerToSave].IslandsN * 2) {Islands pointers }
            + (LayA[LayerToSave].TotalPnts * 16)
            + 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    end;
  18:{MultiPoint Z+M}
    begin
      ShapeFileSize :=
            ((LayA[LayerToSave].ShapeN * (28+8))
            + (LayA[LayerToSave].IslandsN * 2) {Islands pointers }
            + (LayA[LayerToSave].TotalPnts * 16)
            + 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    end;
  21:  {Point M}
    Begin
     ShapeFileSize := ((LayA[LayerToSave].ShapeN * (10+4+4)) + 50);
     IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    End;
  23..25: {Line Poly +M}
    begin
      ShapeFileSize :=
            ((LayA[LayerToSave].ShapeN * (28+4))
            + (LayA[LayerToSave].IslandsN * 2) {Islands pointers }
            + (LayA[LayerToSave].TotalPnts * 12)
            + 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    end;
  28:{MultiPoint M}
    begin
      ShapeFileSize :=
            ((LayA[LayerToSave].ShapeN * (28+4))
            + (LayA[LayerToSave].IslandsN * 2) {Islands pointers }
            + (LayA[LayerToSave].TotalPnts * 12)
            + 50);
      IndexFileSize := ((LayA[LayerToSave].ShapeN * 4) + 50);
    end;
  End;{Case}
    {Write the file size}
  SwapShapeInteger(ShapeFileSize);
  SwapIndexInteger(IndexFileSize);
    {Version}
  ShapeInteger := 1000;
  BlockWrite(ShapeFileOut, ShapeInteger, 4);
  BlockWrite(IndexFileOut, ShapeInteger, 4);

     {Shapetype}
  BlockWrite(ShapeFileOut, LayA[LayerToSave].ShpType, 4);
  BlockWrite(IndexFileOut, LayA[LayerToSave].ShpType, 4);
        {XMIN,YMIN,XMAX,YMAX:Double;}
  BlockWrite(ShapeFileOut, LayA[LayerToSave].XMIN, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].XMIN, 8);
  BlockWrite(ShapeFileOut, LayA[LayerToSave].YMIN, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].YMIN, 8);
  BlockWrite(ShapeFileOut, LayA[LayerToSave].XMAX, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].XMAX, 8);
  BlockWrite(ShapeFileOut, LayA[LayerToSave].YMAX, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].YMAX, 8);
        {M and Z}
  BlockWrite(ShapeFileOut, LayA[LayerToSave].ZMIN, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].ZMIN, 8);
  BlockWrite(ShapeFileOut, LayA[LayerToSave].ZMAX, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].ZMAX, 8);
        {M and Z}
  BlockWrite(ShapeFileOut, LayA[LayerToSave].MMIN, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].MMIN, 8);
  BlockWrite(ShapeFileOut, LayA[LayerToSave].MMAX, 8);
  BlockWrite(IndexFileOut, LayA[LayerToSave].MMAX, 8);


  {HEADER Written... NOW write Shape Objects}
  HintsLabel.Caption := 'Writing Shape File';
  Application.ProcessMessages;
  if ((Shapetype = 1) )then
  begin {Writing Points}
    Count := LayA[LayerToSave].ShapeN;
    IndexOffsetTotal:= 50;
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;
      PointCount :=Incrementer;
      SwapShapeInteger(PointCount);
      {Record Number starts with 1}
      {Offset incremented for start of NEXT one}
      IndexOffset :=IndexOffsetTotal;
      SwapIndexInteger(IndexOffset);
      {Index offset = Content Length +header}
      IndexOffsetTotal:=IndexOffsetTotal + 10 + 4;
       {Content Length.. not content + header}
      SwapShapeInteger(10);
      SwapIndexInteger(10);
      ShapeInteger := (ShapeType); {Shape Type=1}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
       {Only 1 point per part, stored in Min,Max NOT Xd,Yd}
      BlockWrite(ShapeFileOut,
          LayA[LayerToSave].LyrShp[Incrementer].XMin, 8);
      BlockWrite(ShapeFileOut,
          LayA[LayerToSave].LyrShp[Incrementer].YMin, 8);
    end;
  end {Shape type 1} else
  if ((Shapetype = 11) )then
  begin {Writing Points}
    Count := LayA[LayerToSave].ShapeN;
    IndexOffsetTotal:= 50;
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;
      PointCount :=Incrementer;
      SwapShapeInteger(PointCount);
       {Record Number starts with 1}
       {Offset incremented for start of NEXT one}
      IndexOffset :=IndexOffsetTotal;
      SwapIndexInteger(IndexOffset);
      {Index offset = Content Length +header}
      IndexOffsetTotal:=IndexOffsetTotal + 18 + 4;
       {Content Length.. not content + header}
      SwapShapeInteger(18);
      SwapIndexInteger(18);
      ShapeInteger := (ShapeType); {Shape Type=1}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      BlockWrite(ShapeFileOut,     {Only 1 point per part}
      LayA[LayerToSave].LyrShp[Incrementer].XMin, 8);
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].YMin, 8);
      ShapeInteger := 0;
      BlockWrite(ShapeFileOut,
          ShapeInteger{LayA[LayerToSave].LyrShp[Incrementer].ZMin}, 8);
      BlockWrite(ShapeFileOut,
          ShapeInteger{LayA[LayerToSave].LyrShp[Incrementer].MMin}, 8);
    end;
  end {Shape type 11} else
  if ((Shapetype = 21) )then
  begin {Writing Points}
    Count := LayA[LayerToSave].ShapeN;
    IndexOffsetTotal:= 50;
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;
      PointCount :=Incrementer;
      SwapShapeInteger(PointCount);
       {Record Number starts with 1}
       {Offset incremented for start of NEXT one}
      IndexOffset :=IndexOffsetTotal;
      SwapIndexInteger(IndexOffset);
      {Index offset = Content Length +header}
      IndexOffsetTotal:=IndexOffsetTotal + 14 + 4;
       {Content Length.. not content + header}
      SwapShapeInteger(14);
      SwapIndexInteger(14);
      ShapeInteger := (ShapeType); {Shape Type=1}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      BlockWrite(ShapeFileOut,     {Only 1 point per part}
         LayA[LayerToSave].LyrShp[Incrementer].XMin, 8);
      BlockWrite(ShapeFileOut,
         LayA[LayerToSave].LyrShp[Incrementer].YMin, 8);
      ShapeInteger := 0;
      BlockWrite(ShapeFileOut,
          ShapeInteger{LayA[LayerToSave].LyrShp[Incrementer].MMin}, 8);
    end;
  end {Shape type 21} else
  (********************************)

  (********************************)
  if ((Shapetype = 3)or(Shapetype = 5)
   or (Shapetype = 13)or(Shapetype = 15)
   or (Shapetype = 23)or(Shapetype = 25)) then
  begin
    Count := LayA[LayerToSave].ShapeN;
    IndexOffsetTotal:= 50;
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;
      {Write Record header}
      PointCount := Incrementer;
      SwapShapeInteger(PointCount); {Record Number}
      IndexOffset :=IndexOffsetTotal;
      SwapIndexInteger(IndexOffset);
      {Index offset + Content Length... for NEXT record... first is 50}
      {Content Length}
      if ((Shapetype = 3)or(Shapetype = 5))then
      RecordSize := (22
      +(LayA[LayerToSave].LyrShp[Incrementer].PartsN* 2)
      + (LayA[LayerToSave].LyrShp[Incrementer].PntsN  * 8)
      {+4}{this header data})
      else if ((Shapetype = 13)or(Shapetype = 15)) then
      RecordSize := (22+8+8 {Z +-}{M +-}
      +(LayA[LayerToSave].LyrShp[Incrementer].PartsN* 2)
      + (LayA[LayerToSave].LyrShp[Incrementer].PntsN  * 16)
      {+4}{this header data})
      else RecordSize := (22+8 {M +-}
      +(LayA[LayerToSave].LyrShp[Incrementer].PartsN* 2)
      + (LayA[LayerToSave].LyrShp[Incrementer].PntsN  * 12)
      {+4}{this header data});
        {Index is Index+  (4 (header)+content)}
      IndexOffsetTotal:=IndexOffsetTotal + RecordSize + 4;
      {Write Record Content}
      SwapShapeInteger(RecordSize);
      SwapIndexInteger(RecordSize);
      ShapeInteger := (ShapeType); {Shape Type is same for FILE}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Object boundaries}
      BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].XMin, 8); {X min}
      BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].YMin, 8); {Y min}
      BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].XMax, 8); {X max}
      BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].YMax, 8); {Y max}
      {Number of Parts... poly lines in THIS arc... }
      ShapeInteger := (LayA[LayerToSave].LyrShp[Incrementer].PartsN);
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Number of Points for ALL polylines in THIS arc... X and Y}
      BlockWrite(ShapeFileOut, LayA[LayerToSave].LyrShp[Incrementer].PntsN, 4);


      PartCount := (LayA[LayerToSave].LyrShp[Incrementer].PartsN);
      {Parts index pointer for start of each line... 0}
      ShapeInteger := (0);
      PartCountTotal:=0;{from 0 array index}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
        {Do first ^ and then any-all the others}
        {Island Index Counter is ALL that determines Rings of a Polygon}
      for PartCounter := 2 to PartCount do  {all have 1 part}
      begin
        ShapeInteger := PartCountTotal+
        LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter-1];
        BlockWrite(ShapeFileOut, ShapeInteger, 4);
        PartCountTotal:=ShapeInteger;
      end;       {AreaRecord Islands}

      for PartCounter := 1 to PartCount  do
      begin
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter];
      for PointCounter := 1 to PointCount do
      begin
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Xd, 8);
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Yd, 8);
      end;
    end;{for PartCounter }

if ((Shapetype = 13)or (Shapetype = 23)) then
begin  {Z ONLY}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMax, 8); {X max}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMin, 8); {Y max}*)
      for PartCounter := 1 to PartCount  do
      begin
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter];
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Zd, 8);}
      end;
    end;{for PartCounter }
end;
if ((Shapetype = 13)or(Shapetype = 15)
or (Shapetype = 23)or(Shapetype = 25)) then
begin {Z and M}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMax, 8); {X max}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMin, 8); {Y max}*)
      for PartCounter := 1 to PartCount  do
      begin
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter];
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Md, 8);}
      end;
    end;{for PartCounter }
end;
  end;{for Incrementer Shapes}
end else
(********************************)

(********************************)
if ((Shapetype = 8)or(Shapetype = 18)or(Shapetype = 28)) then
begin
  Count := LayA[LayerToSave].ShapeN;
{  IndexOffset := 50;}
{  PointCount := 1;}
  IndexOffsetTotal:= 50;
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
ProgressBar.Position:=(Count div Incrementer);
Application.ProcessMessages;
{Write Record header}
      PointCount := Incrementer;
      SwapShapeInteger(PointCount); {Record Number}
      IndexOffset :=IndexOffsetTotal;
      SwapIndexInteger(IndexOffset);
      {Index offset + Content Length... for NEXT record... first is 50}
if ((Shapetype = 8)) then
      RecordSize := (18{22}
      +(LayA[LayerToSave].LyrShp[Incrementer].PartsN* 2)
      + (LayA[LayerToSave].LyrShp[Incrementer].PntsN  * 8)
      {+4}{this header data})
else if ((Shapetype = 18)) then
      RecordSize := (18{22}+16
      +(LayA[LayerToSave].LyrShp[Incrementer].PartsN* 2)
      + (LayA[LayerToSave].LyrShp[Incrementer].PntsN  * 16)
      {+4}{this header data})
else {if ((Shapetype = 28)) then}
      RecordSize := (18{22}+8
      +(LayA[LayerToSave].LyrShp[Incrementer].PartsN* 2)
      + (LayA[LayerToSave].LyrShp[Incrementer].PntsN  * 12)
      {+4}{this header data});
        {Content Length}
      IndexOffsetTotal:=IndexOffsetTotal + RecordSize + 4;
        {Index is Index+  (4 (header)+content)}
      SwapShapeInteger(RecordSize);
      SwapIndexInteger(RecordSize);
{Write Record Content}
      ShapeInteger := (ShapeType); {Shape Type is same for FILE}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Object boundaries}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].XMin, 8); {X min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].YMin, 8); {Y min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].XMax, 8); {X max}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].YMax, 8); {Y max}
      {Number of Points  in THIS set... X and Y}
      BlockWrite(ShapeFileOut, LayA[LayerToSave].LyrShp[Incrementer].PntsN, 4);
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PntsN;
      for PointCounter := 1 to PointCount do
      begin
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Xd, 8);
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Yd, 8);
      end;
      If (ShapeType=18) then {Z 18 only}
      begin{Z}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMin, 8); {Z min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMax, 8); {Z max}*)
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Zd, 8);}
      end;
      end;
      If (ShapeType>8) then {18 and 28}
      begin{M}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMin, 8); {M min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMax, 8); {M max}*)
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Md, 8);}
      end;
      end;
    end;
end;
ProgressBar.Position:=0;
      CloseFile(IndexFileOut);
      CloseFile(ShapeFileOut);
ShapeLoaderForm.Hide;
End;
(*************************************************************)
(*************************************************************)

procedure TShapeLoaderForm.SaveShpDatFile(LayerToSave:Integer;FileName:String);
var
  ShapeFileOut: file of Double;
  temp: string;
  ShapetypeD:Double;
  ShapeByte: Byte;
  Incrementer, IndexOffsetTotal,
  PartCount,PartCounter,
  PointCount,PointCounter, PartCountTotal,
  Count, Shapetype, ShapeInteger: Integer;
  ShapeFileSize, IndexFileSize,
  RecordSize,  IndexOffset  : integer;
Begin
  {Write the Layer to a Shape file
   .shp  .shx  .dbf .sbx is an index to another .db}
  ShapeLoaderForm.Show;
     {Set up Shape and Index file}
  temp := ChangeFileExt(FileName, '.dat');
  AssignFile(ShapeFileOut, temp);
  Rewrite(ShapeFileOut);
  ProgressBar.Position:=0;
  Application.ProcessMessages;


  {Compute and Write File size}
  Shapetype:=LayA[LayerToSave].ShpType;
  ShapetypeD:=LayA[LayerToSave].ShpType;
     {Shapetype}
  Write(ShapeFileOut,ShapetypeD);
        {XMIN,YMIN,XMAX,YMAX:Double;}
  Write(ShapeFileOut, LayA[LayerToSave].XMIN);
  Write(ShapeFileOut, LayA[LayerToSave].YMIN);
  Write(ShapeFileOut, LayA[LayerToSave].XMAX);
  Write(ShapeFileOut, LayA[LayerToSave].YMAX);
        {M and Z}
  Write(ShapeFileOut, LayA[LayerToSave].ZMIN);
  Write(ShapeFileOut, LayA[LayerToSave].ZMAX);
        {M and Z}
  Write(ShapeFileOut, LayA[LayerToSave].MMIN);
  Write(ShapeFileOut, LayA[LayerToSave].MMAX);

  {HEADER Written... NOW write Shape Objects}
  HintsLabel.Caption := 'Writing Shape File';
  Application.ProcessMessages;
  if ((Shapetype = 1) )then
  begin {Writing Points}
    Count:= LayA[LayerToSave].ShapeN;
    ShapetypeD := LayA[LayerToSave].ShapeN;
    Write(ShapeFileOut, ShapetypeD);
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;
       {Only 1 point per part, stored in Min,Max NOT Xd,Yd}
      Write(ShapeFileOut,
          LayA[LayerToSave].LyrShp[Incrementer].XMin);
      Write(ShapeFileOut,
          LayA[LayerToSave].LyrShp[Incrementer].YMin);
    end;
  end {Shape type 1} else
  if ((Shapetype = 11) )then
  begin {Writing Points}
    Count:= LayA[LayerToSave].ShapeN;
    ShapetypeD := LayA[LayerToSave].ShapeN;
    Write(ShapeFileOut,ShapetypeD);
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;
      Write(ShapeFileOut,     {Only 1 point per part}
      LayA[LayerToSave].LyrShp3[Incrementer].XMin);
      Write(ShapeFileOut,
      LayA[LayerToSave].LyrShp3[Incrementer].YMin);
      Write(ShapeFileOut,
          LayA[LayerToSave].LyrShp3[Incrementer].ZMin);
      Write(ShapeFileOut,
          LayA[LayerToSave].LyrShp3[Incrementer].MMin);
    end;
  end {Shape type 11} else
  if ((Shapetype = 21) )then
  begin {Writing Points}
    Count:= LayA[LayerToSave].ShapeN;
    ShapetypeD := LayA[LayerToSave].ShapeN;
    Write(ShapeFileOut, ShapetypeD);
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;

      Write(ShapeFileOut,     {Only 1 point per part}
         LayA[LayerToSave].LyrShp3[Incrementer].XMin);
      Write(ShapeFileOut,
         LayA[LayerToSave].LyrShp3[Incrementer].YMin);
      Write(ShapeFileOut,
          LayA[LayerToSave].LyrShp3[Incrementer].MMin);
    end;
  end {Shape type 21} else
  (********************************)

  (********************************)
  if ((Shapetype = 3)or(Shapetype = 5)
   or (Shapetype = 13)or(Shapetype = 15)
   or (Shapetype = 23)or(Shapetype = 25)) then
  begin
    Count:= LayA[LayerToSave].ShapeN;
    ShapetypeD := LayA[LayerToSave].ShapeN;
    Write(ShapeFileOut,ShapetypeD);
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
      ProgressBar.Position:=(Count div Incrementer);
      Application.ProcessMessages;

      {Number of Points for ALL polylines in THIS arc... X and Y}
      {ShapetypeD := LayA[LayerToSave].LyrShp[Incrementer].PntsN;
      Write(ShapeFileOut,ShapetypeD );}


      PartCount := (LayA[LayerToSave].LyrShp[Incrementer].PartsN);
      {Parts index pointer for start of each line... 0}
      ShapeInteger := (0);
      PartCountTotal:=0;{from 0 array index}
      {BlockWrite(ShapeFileOut, ShapeInteger, 4);}
        {Do first ^ and then any-all the others}
        {Island Index Counter is ALL that determines Rings of a Polygon}
        {all have 1 part}
      {for PartCounter := 2 to PartCount do
      begin
        ShapeInteger := PartCountTotal+
        LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter-1];
        Write(ShapeFileOut, ShapeInteger);
        PartCountTotal:=ShapeInteger;
      end; }      {AreaRecord Islands}
      ShapetypeD := PartCount;
      Write(ShapeFileOut,ShapetypeD );
      for PartCounter := 1 to PartCount  do
      begin
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter];
      ShapetypeD := PointCount;
      Write(ShapeFileOut,ShapetypeD );
      for PointCounter := 1 to PointCount do
      begin
        Write(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Xd);
        Write(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Yd);
      end;
    end;{for PartCounter }

if ((Shapetype = 13)or (Shapetype = 23)) then
begin  {Z ONLY}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMax, 8); {X max}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMin, 8); {Y max}*)
      for PartCounter := 1 to PartCount  do
      begin
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter];
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Zd, 8);}
      end;
    end;{for PartCounter }
end;
if ((Shapetype = 13)or(Shapetype = 15)
or (Shapetype = 23)or(Shapetype = 25)) then
begin {Z and M}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMax, 8); {X max}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMin, 8); {Y max}*)
      for PartCounter := 1 to PartCount  do
      begin
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PPA[PartCounter];
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[PartCounter].PA[PointCounter].Md, 8);}
      end;
    end;{for PartCounter }
end;
  end;{for Incrementer Shapes}
end else
(********************************)
{MultiPoint}
(********************************)
if ((Shapetype = 8)or(Shapetype = 18)or(Shapetype = 28)) then
begin
  Count := LayA[LayerToSave].ShapeN;
{  IndexOffset := 50;}
{  PointCount := 1;}
  IndexOffsetTotal:= 50;
    for Incrementer := 1 to LayA[LayerToSave].ShapeN do
    begin
ProgressBar.Position:=(Count div Incrementer);
Application.ProcessMessages;

{Write Record Content}
      ShapeInteger := (ShapeType); {Shape Type is same for FILE}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Object boundaries}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].XMin, 8); {X min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].YMin, 8); {Y min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].XMax, 8); {X max}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].YMax, 8); {Y max}
      {Number of Points  in THIS set... X and Y}
      BlockWrite(ShapeFileOut, LayA[LayerToSave].LyrShp[Incrementer].PntsN, 4);
        PointCount:=
          LayA[LayerToSave].LyrShp[Incrementer].PntsN;
      for PointCounter := 1 to PointCount do
      begin
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Xd, 8);
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Yd, 8);
      end;
      If (ShapeType=18) then {Z 18 only}
      begin{Z}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMin, 8); {Z min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].ZMax, 8); {Z max}*)
      for PointCounter := 1 to PointCount do
      begin
{        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp[Incrementer].PARA[1].PA[PointCounter].Zd, 8);}
      end;
      end;
      If (ShapeType>8) then {18 and 28}
      begin{M}
(*      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMin, 8); {M min}
      BlockWrite(ShapeFileOut,
      LayA[LayerToSave].LyrShp[Incrementer].MMax, 8); {M max}*)
      for PointCounter := 1 to PointCount do
      begin
        BlockWrite(ShapeFileOut,
        LayA[LayerToSave].LyrShp3[Incrementer].PARA3[1].PA3[PointCounter].Md, 8);
      end;
      end;
    end;
end;
  ProgressBar.Position:=0;
  CloseFile(ShapeFileOut);
  ShapeLoaderForm.Hide;
End;
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)

procedure TShapeLoaderForm.SaveShpDXFFile(LayerToSave:Integer;FileName:String);
var
DxfOutFile: TextFile;
{ AnythingGoS,dxfXTempS, dxfYTempS, DXFLineWidthS: string;}
 INumparts,  INumPoints,
 ShapeType, ShapeToDo,
 NumShape, NumParts, NumPoints: integer;
{ dZTemp,}dXTemp, dYTemp:Double;
Begin
{Write the Layer to a DXF File}
    AssignFile(DxfOutFile, FileName);
    Rewrite(DxfOutFile);
{Header comment and header section
It is common for the first line of a DXF file to contain a comment,
the group code for comments is 999.}
    Writeln(DxfOutFile, inttostr(999));
    Writeln(DxfOutFile, 'Ver 1.0 VOICE 2D dxf');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'SECTION');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'HEADER');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDSEC');

{Tables Section
    These can be used to specify predefined constants, line styles, text styles, view
    tables, user coordinate systems, etc. We will only use tables to define some layers
    for use later on. Note: not all programs that support DXF import will support
    layers and those that do usually insist on the layers being defined before use. The
    following will initialise layer 1 for use later on.}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'SECTION');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'TABLES');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'TABLE');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'LAYER');
    {?}
    {Writeln(DxfOutFile, 70);
    Writeln(DxfOutFile, 153);}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'LAYER');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, '0'); {layer name}
    {?}
{    Writeln(DxfOutFile, 70);
    Writeln(DxfOutFile, 0);}
    {Color}
    {Writeln(DxfOutFile, 62);
    Writeln(DxfOutFile, 15);}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDTAB');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDSEC');

{Blocks section
    Not necessary here but it's good form to include one anyway. The following is an
    empty block section.}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'SECTION');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'BLOCKS');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDSEC');

{Entities section
    The entities section is where the geometric elements of the model or scene are
    described. The following is the standard form of the entities section.
    0 SECTION 2 ENTITIES <Geometric entities go here> 0 ENDSEC}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'SECTION');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'ENTITIES');
    {thickness}
    {Writeln(DxfOutFile, 39);
    Writeln(DxfOutFile, 1);}
{Colour
    Only index colour is supported,
    it is done with group code 62 within an entity description.
    The value is the colour index.}
{Layers
    Layer numbers are specified with group code 8 within an entity description. The
    layers to be used should be defined as described earlier in the tables section. Most
    DXF importers will insist on predefining the layers in the tables. Note: the
    number of layers possible will vary on the software used to import the DXF file.
    The following indicates that the current entity is to be placed on layer 2
    8
    2}
{Geometry
    DXF explicitly supports two 3D primitive types, namely, 3DFACE and 3DLINE
    (usual to just use plain LINE primitive). LINE consists of the two endpoints,
    3DFACE specifies either three or four vertex facets (polygonal bounded planes).
    All four vertices must be specified, in the case of a three point facet the last vertex
    is specified twice. In general vertex group codes are numbers 10,20,30 for the first
    (x,y,z) triple, 11,21,31 for the second, 12,22,32 for the third and 13,23,33 for the
    fourth. Each vertex group code is followed by the appropriate coordinate value.
    Note: that there is no requirement for the four vertices specifying the facet to be
    planar but it may be important for the software that imports the DXF file. The
    vertices can be ordered clockwise or anticlockwise with respect to the outward
    pointing normal, however some modellers may insist on a particular
    orientation, especially rendering software.}
      ShapeType:= LayA[LayerToSave].ShpType;
      NumShape:= LayA[LayerToSave].ShapeN;
      {Point}
      If ( (ShapeType=1) or (ShapeType=11) or (ShapeType=21) )then
        begin
          For ShapeToDo:=1 to NumShape do
          Begin
ProgressBar.Position:=Round((ShapeToDo/NumShape)*100);
          Writeln(DxfOutFile, inttostr(0));
          Writeln(DxfOutFile, 'POINT');
          Writeln(DxfOutFile, inttostr(8));{Layer}
          Writeln(DxfOutFile, '0');
            dXTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].XMin;
            dYTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].YMin;
                  Writeln(DxfOutFile, inttostr(10));
                  Writeln(DxfOutFile,FloatToStrF(dXTemp, ffFixed,5,1));
                  Writeln(DxfOutFile, inttostr(20));
                  Writeln(DxfOutFile,FloatToStrF(dYTemp, ffFixed,5,1));
                  Writeln(DxfOutFile, inttostr(30));
               If ((ShapeType=15) or (ShapeType=13))then
               begin
{                 dZTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].ZMin;
                 Writeln(DxfOutFile,FloatToStrF(dZTemp, ffFixed,5,1));}
               end
               else  Writeln(DxfOutFile, '0.000000');
        Writeln(DxfOutFile, inttostr(0));
        Writeln(DxfOutFile, 'SEQEND');
          Writeln(DxfOutFile, inttostr(8));
          Writeln(DxfOutFile, '0');
          end;
        end;
      {Lines and Polys... into PolyLines}
      If ( (ShapeType=3) or (ShapeType=13) or (ShapeType=23)or
         (ShapeType=5) or (ShapeType=15) or (ShapeType=25))then
        {3..5:}
        begin
          For ShapeToDo:=1 to NumShape do
          Begin
ProgressBar.Position:=Round((ShapeToDo/NumShape)*100);

            Numparts:=LayA[LayerToSave].LyrShp[ShapeToDo].PartsN;{Numparts}

            for INumparts := 1 to Numparts do
            begin {Always at least 1 0...}
{dxf header stuff}
 {Write out Line header}
          Writeln(DxfOutFile, inttostr(0));
          Writeln(DxfOutFile, 'POLYLINE');
          Writeln(DxfOutFile, inttostr(8));{Layer}
          Writeln(DxfOutFile, '0');
          Writeln(DxfOutFile, inttostr(70));
{          Writeln(DxfOutFile, inttostr(8));}
    If ( (ShapeType=3) or (ShapeType=13) or (ShapeType=23))then
       Writeln(DxfOutFile, inttostr(8)) {3D polyline}
       else   Writeln(DxfOutFile, inttostr(1));{closed polyline}
          Writeln(DxfOutFile, inttostr(66));
          Writeln(DxfOutFile, inttostr(1));
          Writeln(DxfOutFile, inttostr(10));{who knows why}
          Writeln(DxfOutFile, '0.000000');
          Writeln(DxfOutFile, inttostr(20));{who knows why}
          Writeln(DxfOutFile, '0.000000');
          Writeln(DxfOutFile, inttostr(30));{who knows why}
          Writeln(DxfOutFile, '0.000000');
(*        Writeln(DxfOutFile, 40);
          Writeln(DxfOutFile, 1{DXFLineWidthS});
          Writeln(DxfOutFile, 41);
          Writeln(DxfOutFile, 1{DXFLineWidthS});*)

              NumPoints:=LayA[LayerToSave].LyrShp[ShapeToDo].PPA[INumparts];
              for INumPoints := 1 to NumPoints-1 do
              begin {2 points internally}
                dXTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Xd;
                dYTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Yd;
                {Write dxf points into line}
                Writeln(DxfOutFile, inttostr(0));
                Writeln(DxfOutFile, 'VERTEX');
                Writeln(DxfOutFile, inttostr(8));{Layer}
                Writeln(DxfOutFile, '0');
                  Writeln(DxfOutFile, inttostr(10));
                  Writeln(DxfOutFile,FloatToStrF(dXTemp, ffFixed,5,1));
                  Writeln(DxfOutFile, inttostr(20));
                  Writeln(DxfOutFile,FloatToStrF(dYTemp, ffFixed,5,1));
                  Writeln(DxfOutFile, inttostr(30));
               If ((ShapeType=15) or (ShapeType=13))then
               begin
{                 dZTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Zd;
                 Writeln(DxfOutFile,FloatToStrF(dZTemp, ffFixed,5,1));}
               end
               else  Writeln(DxfOutFile, '0.000000');
               (* Writeln(DxfOutFile, 42);
                  Writeln(DxfOutFile, 0);
                  Writeln(DxfOutFile, 70);
                  Writeln(DxfOutFile, 32);*)
               If ((ShapeType=3) or (ShapeType=13)or (ShapeType=23))then
               begin {real lines get all the points.. polys skip last point}
                dXTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].PARA[INumparts].PA[NumPoints].Xd;
                dYTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].PARA[INumparts].PA[NumPoints].Yd;
                {Write dxf points into line}
                Writeln(DxfOutFile, inttostr(0));
                Writeln(DxfOutFile, 'VERTEX');
                Writeln(DxfOutFile, inttostr(8));{Layer}
                Writeln(DxfOutFile, '0');
                  Writeln(DxfOutFile, inttostr(10));
                  Writeln(DxfOutFile,FloatToStrF(dXTemp, ffFixed,5,1));
                  Writeln(DxfOutFile, inttostr(20));
                  Writeln(DxfOutFile,FloatToStrF(dYTemp, ffFixed,5,1));
                  Writeln(DxfOutFile, inttostr(30));
               If ((ShapeType=13))then
               begin
{                 dZTemp:=LayA[LayerToSave].LyrShp[ShapeToDo].PARA[INumparts].PA[NumPoints].Zd;
                 Writeln(DxfOutFile,FloatToStrF(dZTemp, ffFixed,5,1));}
               end
               else  Writeln(DxfOutFile, '0.000000');
               end;
             end;{INumPoints}
{Write out Line }
        Writeln(DxfOutFile, inttostr(0));
        Writeln(DxfOutFile, 'SEQEND');
          Writeln(DxfOutFile, inttostr(8));
          Writeln(DxfOutFile, '0');
            end;{INumparts}
          end;{ShapeToDo}
         end;{ShapeType}

{End of Entities}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDSEC');
{    End of file
    This simply indicates the end of the DXF file,
    it is not usually necessary but good form.}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'EOF');
    CloseFile(DxfOutFile);
End;
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
Function TShapeLoaderForm.LoadDatabase(WhichLayer:Integer):Boolean;
var
{MyBuffer:Pointer;}
TempS,
  DBName, DBPath:String;
{  Min , Max,}
  ii,i,Test:Integer;
{  Table1:TTable;}
Begin
ProgressBar.Position:=0;
  Test:=0;
  Try
  LayA[WhichLayer].LayerDBName:=
     ChangeFileExt(LayA[WhichLayer].Filename,'.dbf');
  DBName:=LayA[WhichLayer].LayerDBName;
  LayA[WhichLayer].LayerDBPath:=LayA[WhichLayer].Path;
  DBPath:=LayA[WhichLayer].Path;

  Table1.Active := False;
  Table1.TableName:=DBPath + DBName;
  Table1.FilePath{DatabaseName} := DBPath;
  Table1.Active := True;

  LayA[WhichLayer].AttributesN:=Table1.FieldDefs.Count;
  SetLength(LayA[WhichLayer].AttType, LayA[WhichLayer].AttributesN);
{type TFieldType =
(ftUnknown, ftString, ftSmallint, ftInteger, ftWord, ftBoolean,
ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime,
ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic,
ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor,
ftFixedChar, ftWideString, ftLargeint, ftADT, ftArray,
 ftReference, ftDataSet, ftOraBlob, ftOraClob, ftVariant,
 ftInterface, ftIDispatch, ftGuid);}
  for i:= 0 to Table1.FieldDefs.Count - 1 do
  begin
    LayA[WhichLayer].AttType[i].FieldNo:=
        Table1.FieldDefs[i].FieldNo;
    LayA[WhichLayer].AttType[i].Displayname:=
        Table1.FieldDefs[i].Name;
    LayA[WhichLayer].AttType[i].DataType:=
        Table1.FieldDefs[i].DataType;
    LayA[WhichLayer].AttType[i].Size:=
        Table1.FieldDefs[i].Size;
    LayA[WhichLayer].AttType[i].Precision:=
        Table1.FieldDefs[i].Precision;
    LayA[WhichLayer].AttType[i].Required:=
        Table1.FieldDefs[i].Required;
  end;


{show message('did db');}
  with ProgressBar do
  begin
    Table1.Last;
    Max :=Table1.RecNo ;{ Table1.RecordCount;}
    Table1.First;
    Min :=Table1.RecNo; {0}
    for i := Min to Max do
    begin
      HintsLabel.Caption:=inttostr(i);
      Application.Processmessages;
      Position := i;
      SetLength(LayA[WhichLayer].LyrShp[i].AAttributes,
            LayA[WhichLayer].AttributesN);

      for ii := 0 to Table1.FieldCount - 1 do
      begin
        If LayA[WhichLayer].AttType[ii].DataType =ftString then
        Begin           { Allocate space }
        If (Table1.Fields[ii].IsNull) then
        begin
           TempS:='x';   {show message('nada');}
           {StringOfChar('x',LayA[WhichLayer].AttType[i].Size);}
           LayA[WhichLayer].LyrShp[i].AAttributes[ii]:=TempS;
        end else
        begin
        TempS:=Table1.Fields[ii].Value{.AsString};
        If Length(TempS)=0 then TempS:='Null';
        LayA[WhichLayer].LyrShp[i].AAttributes[ii]:= TempS;
             {  copy(TempS,1,LayA[WhichLayer].AttType[i].Size)}
        end;

        End else
        If (
            (LayA[WhichLayer].AttType[ii].DataType =ftSmallint)
         or (LayA[WhichLayer].AttType[ii].DataType =ftInteger)
         or (LayA[WhichLayer].AttType[ii].DataType =ftWord)
         or (LayA[WhichLayer].AttType[ii].DataType =ftLargeint)
        ) then
        Begin    { Allocate space }
          LayA[WhichLayer].LyrShp[i].AAttributes[ii]:=
               IntToStr(Table1.Fields[ii].Value)

        End else
        If LayA[WhichLayer].AttType[ii].DataType =ftBoolean then
        Begin    { Allocate space }
          If Table1.Fields[ii].Value then
           LayA[WhichLayer].LyrShp[i].AAttributes[ii]:='True'
           else LayA[WhichLayer].LyrShp[i].AAttributes[ii]:='False'
        End else
        If LayA[WhichLayer].AttType[ii].DataType =ftFloat then
        Begin    { Allocate space }
          LayA[WhichLayer].LyrShp[i].AAttributes[ii]:=
               FloatToStr(Table1.Fields[ii].Value)
        End else
        If LayA[WhichLayer].AttType[ii].DataType =ftCurrency then
        Begin    { Allocate space }
          LayA[WhichLayer].LyrShp[i].AAttributes[ii]:=
               Table1.Fields[ii].Value.AsCurrency
        End else
        If LayA[WhichLayer].AttType[ii].DataType =ftDateTime then
        Begin    { Allocate space }
          LayA[WhichLayer].LyrShp[i].AAttributes[ii]:=
               Table1.Fields[ii].Value.AsDateTime
        End else
        LayA[WhichLayer].LyrShp[i].AAttributes[ii]:='Unknown Lost Value';
      end;
      Table1.Next;
    end;
  end;
  Result:=True;
  Test:=1;
  Finally
  If Test=0 then Result:=False;
  Table1.Active := False;
  Table1.TableName:='';
  Table1.FilePath{DatabaseName} := '';
  end;
ProgressBar.Position:=0;
End;


Function TShapeLoaderForm.SaveDatabase(WhichLayer:Integer):Boolean;
var
  i,ii,Test:Integer;
  TempS:String;
{  dbTable: TTable;}
Begin
  Test:=0;
  Try
  {RunTimeDbCreate(const DatabaseName, SessionName: String): TDatabase;}
  {The following code fragment illustrates how you might
   call this function to create a database component
   for the default session at runtime:}
  LayerDBCount := 1;
  SetLength(LayDatabase,1);
  LayDatabase[LayerDBCount] :=
     RunTimeDbCreate('Layer' +LayA[WhichLayer].LayerDBName,
     LayA[WhichLayer].Path,
      '');
      {IntToStr(LayerDBCount)}
  { Later, create a database component at runtime }

  {Make a database table}
  {dbTable:=TTable.Create(ShapeLoaderForm); }
  with Dbf1 do
  begin
    Active:=False;
    {DatabaseName}
    FilePath:='sshift'+ IntToStr(LayerDBCount);
    {TableType := ttDBase;}
     TableLevel:=3;
        Close;  
    TableName:=LayA[WhichLayer].LayerDBName;
    with FieldDefs do
    begin
      Clear;
      for i:= 0 to LayA[WhichLayer].AttributesN - 1 do
      begin
        with AddFieldDef do
        begin
          FieldNo:=LayA[WhichLayer].AttType[i].FieldNo;
          Name := LayA[WhichLayer].AttType[i].Displayname;
          DataType := LayA[WhichLayer].AttType[i].DataType;
          Size:=LayA[WhichLayer].AttType[i].Size ;
          Precision:=LayA[WhichLayer].AttType[i].Precision;
          Required:=LayA[WhichLayer].AttType[i].Required;
        end;
      end;
    End;{FieldDefs}
(*    { Next, describe any indexes }
    with IndexDefs do begin
      Clear;
      { The 1st index has no name because it is
      { a Paradox primary key }
      with AddIndexDef do begin

        Name := '';
        Fields := 'Field1';
        Options := [ixPrimary];
      end;
*)
   CreateTable;
   Dbf1.Active := True;
   ProgressBar.Position:=0;
  with ProgressBar do
  begin
    Min :=1;
    Max :=LayA[WhichLayer].ShapeN;{ Table1.RecordCount;}
    for i := Min to Max do
    begin
    Dbf1.Append;
      Position := i;
      for ii := 0 to LayA[WhichLayer].AttributesN - 1 do
      begin
        If LayA[WhichLayer].AttType[ii].DataType =ftString then
        begin
        TempS:=LayA[WhichLayer].LyrShp[i].AAttributes[ii];
        If (Length(LayA[WhichLayer].LyrShp[i].AAttributes[ii])
        > LayA[WhichLayer].AttType[i].Size)then
        TempS:=copy(LayA[WhichLayer].LyrShp[i].AAttributes[ii],1,LayA[WhichLayer].AttType[i].Size);
        Dbf1.Fields[ii].Value:= TempS
        {LayA[WhichLayer].LyrShp[i].AAttributes[ii] }
        end
        else If (
            (LayA[WhichLayer].AttType[ii].DataType =ftSmallint)
         or (LayA[WhichLayer].AttType[ii].DataType =ftInteger)
         or (LayA[WhichLayer].AttType[ii].DataType =ftWord)
         or (LayA[WhichLayer].AttType[ii].DataType =ftLargeint)
        ) then
        Dbf1.Fields[ii].Value:=
        StrToInt(LayA[WhichLayer].LyrShp[i].AAttributes[ii])
        else If LayA[WhichLayer].AttType[ii].DataType =ftBoolean then
        begin
            If LayA[WhichLayer].LyrShp[i].AAttributes[ii]='True' then
           Dbf1.Fields[ii].Value.AsBoolean:= True
           else Dbf1.Fields[ii].Value.AsBoolean:= False
        end
        else If LayA[WhichLayer].AttType[ii].DataType =ftFloat then
        Dbf1.Fields[ii].Value:=
             StrToFloat(LayA[WhichLayer].LyrShp[i].AAttributes[ii])
        else If LayA[WhichLayer].AttType[ii].DataType =ftCurrency then
        Dbf1.Fields[ii].Value.AsCurrency:=
        LayA[WhichLayer].LyrShp[i].AAttributes[ii]
        else If LayA[WhichLayer].AttType[ii].DataType =ftDateTime then
        Dbf1.Fields[ii].Value.AsDateTime:=
        LayA[WhichLayer].LyrShp[i].AAttributes[ii]
        else
        Dbf1.Fields[ii].Value:=ftUnknown;
      end;
    end;
    Dbf1.Post;
  end;

   Dbf1.Active := False;
   end;{Dbtable}
  Result:=True;
  Test:=1;
  {dbTable.Free;}
  Finally
  If Test=0 then Result:=False;
   LayerDBCount := 0;
   SetLength(LayDatabase,0);
   ProgressBar.Position:=0;
  end;
End;

{---------------------------------------------------------------------}

function TShapeLoaderForm.RunTimeDbCreate(
  const DatabaseName, InPath, SessionName: string): TDatabase;
var
  TempDatabase: TDatabase;
begin
  TempDatabase := nil;{RunTimeDbCreate:=TempDatabase;}
  try
    { If the session exists, make it active; if not, create a new session }
    Sessions.OpenSession(SessionName);
    with Sessions do
      with FindSession(SessionName) do begin
        Result := FindDatabase(DatabaseName);
        if (Result = nil) then begin
          { Create a new database component }
          TempDatabase := TDatabase.Create(Self);
          TempDatabase.DatabaseName :=
            {'sshift' + IntToStr(MyDbCount)}
             DatabaseName;
          TempDatabase.SessionName := SessionName;
          ConfigMode := cmSession;
          try
            AddStandardAlias(DatabaseName, InPath, 'DBASE');
          finally
            ConfigMode := cmAll;
            TempDatabase.KeepConnection := False; {True;}
          end; {finally}
        end; {Result}
        Result := OpenDatabase(DatabaseName);
      end;
  except
    TempDatabase.Free;
    raise;
  end;
end;
(*************************************************************)
(*************************************************************)



(*************************************************************)
(*************************************************************)
{       ShapePath := ExtractFilePath(OpenDialog.Filename);
       ShpFileName := OpenDialog.Filename;}
{This reads a Shape file into an Array
Someday: Make a Direct File Access
to read from file and thus have NO storage
Store 'header' of each object? and File Offset for Points?}
Function TShapeLoaderForm.LoadLayer:Boolean;
var
 ShapeFileIn: file;
 InString:String;
 BufByte:Byte;
 ShapeType,
 PointCount, IslandCount,
 {AreaCount,}FileSizeCheck,FileSizeChecker,
 NumShape, NumParts, NumPoints,
 ShapeNumber, PartNumber, PointNumber,
 ICOIn,{ICO,} BufI,ByteArray, I: integer;
  dXTemp, dYTemp:Double;
  function SwapShapeByte: Integer;
  var aByteArray, oByteArray: array[0..3] of Byte;
    Outgoing: Integer;
  begin
    Move(ByteArray, aByteArray, 4);
    oByteArray[0] := aByteArray[3];
    oByteArray[1] := aByteArray[2];
    oByteArray[2] := aByteArray[1];
    oByteArray[3] := aByteArray[0];
    Move(oByteArray, Outgoing, 4);
    Result := Outgoing;
  end;
  function SwapShapeInteger(InInteger:Integer): Integer;
  var
    aByteArray, oByteArray: array[0..3] of Byte;
    Outgoing: Integer;
  begin
    Move(InInteger, aByteArray, SizeOf(aByteArray));
    oByteArray[0] := aByteArray[3];
    oByteArray[1] := aByteArray[2];
    oByteArray[2] := aByteArray[1];
    oByteArray[3] := aByteArray[0];
    Move(oByteArray, Outgoing, SizeOf(Outgoing));
    Result := Outgoing;
  end;
begin
  Result:=False;
  Try
  Begin
    AssignFile(ShapeFileIn, ShpFileName);
    Reset(ShapeFileIn, 1); { Record size = 1 }
    Application.ProcessMessages;
    PointCount := 0;
    IslandCount := 0;      {AreaCount := 0; }
    ShapeNumber :=0;
    NumShape:=0;
    LayA[CurrentLayer].Modified:=False;

    {Set up Shape}
    BlockRead(ShapeFileIn, ByteArray, 4); {9994 file code}
    str(SwapShapeInteger(ByteArray), InString);
    {ShapeViewMemo.Lines.Add('9994 file code: ' + InString);}

    for I := 1 to 5 do
    begin {5 blank zeros}
        BlockRead(ShapeFileIn, ByteArray, 4);
        str(SwapShapeInteger(ByteArray), InString);
       {ShapeViewMemo.Lines.Add('zero: ' + InString);}
    end;
    BlockRead(ShapeFileIn, ByteArray, 4);
    BlockRead(ShapeFileIn, BufI, 4); {Version 1000}
    If BufI <> 1000 then exit;{New version}
    {ShapeViewMemo.Lines.Add('Version 1000: ' + Inttostr(BufI));}
    BlockRead(ShapeFileIn, BufI, 4);{Shapetype}
    ShapeType := BufI;
    {ShapeViewMemo.Lines.Add('Shapetype: ' + Inttostr(BufI));}
    LayA[CurrentLayer].LayerN:=CurrentLayer;
    LayA[CurrentLayer].ShpType:=ShapeType;
    LayA[CurrentLayer].Modified:=False;
    LayA[CurrentLayer].Filename:=ExtractFileName(ShpFileName);
    LayA[CurrentLayer].Path:=ExtractFilePath(ShpFileName);
    {Place Shape type into record}
    BlockRead(ShapeFileIn, dXMIN, 8);
    {ShapeViewMemo.Lines.Add('XMIN: '  + Floattostr(dXMIN));}
    BlockRead(ShapeFileIn, dYMIN, 8);
    {ShapeViewMemo.Lines.Add('YMIN: '  + Floattostr(dYMIN));}
    BlockRead(ShapeFileIn, dXMAX, 8);
    {ShapeViewMemo.Lines.Add('XMAX: '  + Floattostr(dXMAX));}
    BlockRead(ShapeFileIn, dYMAX, 8);
    {ShapeViewMemo.Lines.Add('YMAX: '  + Floattostr(dYMAX));}
    {Place XMIN,YMIN,XMAX,YMAX:Double; into record}
    LayA[CurrentLayer].XMin:= dXMIN;
    LayA[CurrentLayer].YMin:= dYMIN;
    LayA[CurrentLayer].XMax:= dXMAX;
    LayA[CurrentLayer].YMax:= dYMAX;
    if dXMIN < 0 then
      LayA[CurrentLayer].OffsetX := {(180+dXMIN)+}abs(dXMIN)
      else if dXMIN > 0 then
      LayA[CurrentLayer].OffsetX  := (0 - dXMIN)
      else LayA[CurrentLayer].OffsetX  := 0;
    if dYMIN < 0 then
      LayA[CurrentLayer].OffsetY := {(90+dYMIN)+}abs(dYMIN)
      else if dYMIN > 0 then
      LayA[CurrentLayer].OffsetY := (0 - dYMIN)
      else LayA[CurrentLayer].OffsetY := 0;

    If abs(LayA[CurrentLayer].OffsetX) > abs(MaxOffsetX) then
       MaxOffsetX:= LayA[CurrentLayer].OffsetX;
    If abs(LayA[CurrentLayer].OffsetY) > abs(MaxOffsetY) then
       MaxOffsetY:= LayA[CurrentLayer].OffsetY;

    If CurrentLayer =1 then
    Begin
      MinOffX:=LayA[CurrentLayer].XMin;
      MinOffY:=LayA[CurrentLayer].YMin;
      MaxOffX:=LayA[CurrentLayer].XMax;
      MaxOffY:=LayA[CurrentLayer].YMax;
    End;
    BlockRead(ShapeFileIn, dXTemp, 8);
    BlockRead(ShapeFileIn, dYTemp, 8);
    LayA[CurrentLayer].ZMin:= dXTemp;
    {ShapeViewMemo.Lines.Add('ZMin: '  + Floattostr(dXTemp));}
    LayA[CurrentLayer].ZMax:= dYTemp;
    {ShapeViewMemo.Lines.Add('ZMax: '  + Floattostr(dYTemp));}
    BlockRead(ShapeFileIn, dXTemp, 8);
    BlockRead(ShapeFileIn, dYTemp, 8);
    LayA[CurrentLayer].MMin:= dXTemp;
    LayA[CurrentLayer].MMax:= dYTemp;
    {ShapeViewMemo.Lines.Add('MMax: '  + Floattostr(dYTemp));}
    {LayA[].ShpLayer.LyrShp[].ShpObj.PARA[PartsN #].PAR.PA[PPA[PartsN #]].Pnts.Xn Yn Zn Mn}

    {******************* BIG SWITCH ******************}
   {==============================================================}
    If ((ShapeType=1)       {Point Type, Box, Numpoints, Points }
        or(ShapeType=11)
        or(ShapeType=21)) then
    begin
      ShapeNumber :=0;
      while (not (eof(ShapeFileIn))) do
      begin
      {Header}
        BlockRead(ShapeFileIn, ICOIn, 4); {Record Number}
        inc(ShapeNumber);
        NumShape:=SwapShapeInteger(ICOIn);{Store total for later}
{LyrShp <> LyrShp3}
        Setlength(LayA[CurrentLayer].LyrShp,ShapeNumber+1);
        HintsLabel.Caption:=Inttostr(NumShape);
        Application.ProcessMessages;
        BlockRead(ShapeFileIn, ByteArray, 4); {Content length}
        FileSizeCheck:=SwapShapeByte;
      {Data per Point}
        Setlength(LayA[CurrentLayer].LyrShp[ShapeNumber].AAttributes,0);
        BlockRead(ShapeFileIn, BufI, 4); {Shapetype Store only #6}
        BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
        LayA[CurrentLayer].LyrShp[ShapeNumber].XMin:= dXTemp;
        LayA[CurrentLayer].LyrShp[ShapeNumber].XMax:= dXTemp;
        BlockRead(ShapeFileIn, dYTemp, 8);
        LayA[CurrentLayer].LyrShp[ShapeNumber].YMin:= dYTemp;
        LayA[CurrentLayer].LyrShp[ShapeNumber].YMax:= dYTemp;
        {Z M POINTS....}
        If (ShapeType=11) then
        begin
          BlockRead(ShapeFileIn, dXTemp, 8);
{          LayA[CurrentLayer].LyrShp[ShapeNumber].ZMin:= dXTemp;}
          BlockRead(ShapeFileIn, dXTemp, 8);
{          LayA[CurrentLayer].LyrShp[ShapeNumber].ZMax:= dXTemp;}
        end;
        If ((ShapeType=11)or(ShapeType=21)) then
        begin
          BlockRead(ShapeFileIn, dYTemp, 8);
{          LayA[CurrentLayer].LyrShp[ShapeNumber].MMin:= dYTemp;}
          BlockRead(ShapeFileIn, dYTemp, 8);
{          LayA[CurrentLayer].LyrShp[ShapeNumber].MMax:= dYTemp;}
        end; {For II}
        {Some shape files have 'proprietary' stuff
          'hidden' in the files...IGNORE it}
        If ((ShapeType=1)and (FileSizeCheck > 10)) then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          for I:= 1 to FileSizeCheck-20 do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end;
        If ((ShapeType=21)and (FileSizeCheck > 18)) then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          for I:= 1 to FileSizeCheck-36 do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end;
        If ((ShapeType=11)and (FileSizeCheck > 26)) then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          for I:= 1 to FileSizeCheck-52 do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end;
        LayA[CurrentLayer].ShapeN:=NumShape;
        LayA[CurrentLayer].TotalPnts:=ShapeNumber;
        LayA[CurrentLayer].IslandsN:=0;
      end;{File}
    end {points} else
    (********************************)
    If ((ShapeType=3) {Line }
          or(ShapeType=13)
          or(ShapeType=23)
          or  (ShapeType=5) { Polygon}
          or(ShapeType=15)
          or(ShapeType=25) ) then
    begin
      ShapeNumber :=0;
      while (not (eof(ShapeFileIn))) do
      begin
        Application.ProcessMessages;
        {inc(AreaCount);}
        BlockRead(ShapeFileIn, ICOIn, 4); {Record Number}
        inc(ShapeNumber);
        NumShape:=SwapShapeInteger(ICOIn);{Store total for later}
        Setlength(LayA[CurrentLayer].LyrShp,ShapeNumber+1);
        {ShapeViewMemo.Lines.Add('Record Number: ' + Inttostr(NumShape));}
              {  Counter status}
        HintsLabel.Caption:=Inttostr(NumShape);

        BlockRead(ShapeFileIn, ByteArray, 4); {Content length}
        FileSizeCheck:=SwapShapeByte;
        {ShapeViewMemo.Lines.Add('Content length: ' + Inttostr(SwapShapeInteger(ByteArray)));}
        Setlength(LayA[CurrentLayer].LyrShp[ShapeNumber].AAttributes,0);
        BlockRead(ShapeFileIn, BufI, 4); {Shapetype}
        {ShapeViewMemo.Lines.Add('Shapetype: ' + Inttostr(BufI));}
              {If not same as Shapetype then error}
        {XMIN,YMIN,XMAX,YMAX:Double;}
        BlockRead(ShapeFileIn, dXMIN, 8);
        {ShapeViewMemo.Lines.Add('XMIN: '  + Floattostr(dXMIN));}
        BlockRead(ShapeFileIn, dYMIN, 8);
        {ShapeViewMemo.Lines.Add('YMIN: '  + Floattostr(dXMIN));}
        BlockRead(ShapeFileIn, dXMAX, 8);
        {ShapeViewMemo.Lines.Add('XMAX: '  + Floattostr(dXMAX));}
        BlockRead(ShapeFileIn, dYMAX, 8);
        {ShapeViewMemo.Lines.Add('YMAX: '  + Floattostr(dYMAX));}
        {LayA[].ShpLayer.LyrShp[].ShpObj.PARA[PartsN #].PAR.PA[PPA[PartsN #]].Pnts.Xn Yn Zn Mn}
        LayA[CurrentLayer].LyrShp[ShapeNumber].XMin:= dXMIN;
        LayA[CurrentLayer].LyrShp[ShapeNumber].YMin:= dYMIN;
        LayA[CurrentLayer].LyrShp[ShapeNumber].XMax:= dXMAX;
        LayA[CurrentLayer].LyrShp[ShapeNumber].YMax:= dYMAX;

        BlockRead(ShapeFileIn, Numparts, 4); {Numparts}
        LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN:=Numparts;
        IslandCount:= IslandCount+(Numparts-1);
        {CHANGE the array size to Numparts}
        SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PPA,Numparts+1);
        SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA,Numparts+1);
        BlockRead(ShapeFileIn, NumPoints, 4); {NumPoints}
        LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
        PointCount:=PointCount+NumPoints;{Total points for File}
        {ShapeViewMemo.Lines.Add('NumPoints: ' + Inttostr(NumPoints));}
        {Ignore storing NumPoints.. use it to read file}
        {If MessageDlg('Got to shape NumPoints '+Inttostr(NumPoints)+' Exit now?'
                  ,mtConfirmation, [mbYes, mbNo], 0)=mrYes then exit;}
        BlockRead(ShapeFileIn, BufI, 4); {Parts... skip first as it is 0}
        {ShapeViewMemo.Lines.Add('Parts Points at: ' + Inttostr(BufI));}
        ICOIn:=0;
        If Numparts >1 then
        begin
          for I := 1 to Numparts-1 do
          begin {Always at least 1 0...}
            BlockRead(ShapeFileIn, BufI, 4); {Parts 2...}
            {ShapeViewMemo.Lines.Add('Parts Points: ' + Inttostr(BufI));}
            LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[I]:=((BufI)-ICOIn);
            {If MessageDlg('Got to shape '+Inttostr(ShapeNumber)
                           +' .BufI. '+Inttostr(BufI)
                           +' .-. '+Inttostr((BufI)-ICOIn)
                           +' .NumPoints. '+Inttostr(NumPoints)
                           +' Exit now?'
                   ,mtConfirmation, [mbYes, mbNo], 0)=mrYes then exit;}
            SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[I].PA,((BufI+1)-ICOIn) );
            ICOIn:=BufI;
          end;
          LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[Numparts]:=((NumPoints-ICOIn));
          SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[Numparts].PA,((NumPoints-ICOIn)+1) );
        end else
        begin
          LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[Numparts]:=NumPoints;{((NumPoints-BufI)+1);}{BufI;}
          SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[Numparts].PA,NumPoints+1);
        end;
        {ShapeViewMemo.Lines.Add('total Points: ' + Inttostr(NumPoints));}
        ICOIn:=0;
        for I := 1 to Numparts do
        begin
          ICOIn:= ICOIn+LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[I];
        end;
        If (ICOIn <> NumPoints) then
        begin
          If MessageDlg('Count Wrong ICOIN= '+Inttostr(ICOIn)
                        +' <>NumPoints: '+Inttostr(NumPoints)
                        +' Exit now?'
                   ,mtConfirmation, [mbYes, mbNo], 0)=mrYes then exit;
        end;
        {GET the Parts array data}
        PartNumber:=1;
        PointNumber:=1;
        {Get the Parts array and use to divide lines}
        for I := 1 to NumPoints do
        begin {2 points internally}
            {SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA,PointNumber+1);}
          BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
          LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Xd:=dXTemp;
          {ShapeViewMemo.Lines.Add('Point X ' + Inttostr(PointNumber)+ ' : ' + Floattostr(dXTemp));}
          BlockRead(ShapeFileIn, dYTemp, 8);
          LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Yd:=dYTemp;
          {ShapeViewMemo.Lines.Add('Point Y ' + Inttostr(PointNumber)+ ' : ' + Floattostr(dYTemp));}
          {Change the Part Number according to the number of points in the Part}
          If (PointNumber = (LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[PartNumber])) then
          begin
            inc(PartNumber);
            PointNumber:=0;
          end;
          inc(PointNumber);
        end;
        {DO Z and M}
        If ((ShapeType=13)or(ShapeType=15) ) then
        begin
          BlockRead(ShapeFileIn, dXMIN, 8);
          BlockRead(ShapeFileIn, dXMAX, 8);
{          LayA[CurrentLayer].LyrShp[ShapeNumber].ZMin:= dXMIN;
          LayA[CurrentLayer].LyrShp[ShapeNumber].ZMAX:= dXMAX;}
          {GET the Parts array data}
          PartNumber:=1;
          PointNumber:=1;
          {Get the Parts array and use to divide lines}
          for I := 1 to NumPoints do
          begin {1 point internally}
            BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
{            LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Zd:=dXTemp;}
            {Change the Part Number according to the number of points in the Part}
            If (PointNumber = (LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[PartNumber])) then
            begin
              inc(PartNumber);
              PointNumber:=0;
            end;
            inc(PointNumber);
          end;{I}
        end;{Z array}

        If ((ShapeType=23)or(ShapeType=25)
          or(ShapeType=13)or(ShapeType=15) ) then
        begin
          BlockRead(ShapeFileIn, dXMIN, 8);
          BlockRead(ShapeFileIn, dXMAX, 8);
{          LayA[CurrentLayer].LyrShp[ShapeNumber].MMin:= dXMIN;
          LayA[CurrentLayer].LyrShp[ShapeNumber].MMAX:= dXMAX;}
          {GET the Parts array data}
          PartNumber:=1;
          PointNumber:=1;
          {Get the Parts array and use to divide lines}
          for I := 1 to NumPoints do
          begin {1 point internally}
            BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
{            LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Md:=dXTemp;}
            {Change the Part Number according to the number of points in the Part}
            If (PointNumber = (LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[PartNumber])) then
            begin
              inc(PartNumber);
              PointNumber:=0;
            end;
            inc(PointNumber);
          end;{I}
        end;{M array}
{        FileSizeCheck:=SwapShapeByte;}
{Compute Actual size of THIS Shape Object}
if ((Shapetype = 3)or(Shapetype = 5))then
      FileSizeChecker := (22
      +(LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN* 2)
      + (LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN  * 8)
      {+4}{this header data})
else if ((Shapetype = 13)or(Shapetype = 15)) then
      FileSizeChecker := (22+8+8 {Z +-}{M +-}
      +(LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN* 2)
      + (LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN  * 16)
      {+4}{this header data})
else FileSizeChecker := (22+8 {M +-}
      +(LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN* 2)
      + (LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN  * 12));
        If ((FileSizeCheck > FileSizeChecker)) then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          FileSizeChecker:=(FileSizeChecker * 2);
          for I:= 1 to FileSizeCheck-FileSizeChecker do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end;
        {FileSizeChecker:=FileSizeCheck*2;
        If FileSizeCheck > FileSizeChecker then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          for I:= 1 to FileSizeCheck-20 do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end;}
      end; {For II File}
      LayA[CurrentLayer].ShapeN:=NumShape;
      LayA[CurrentLayer].TotalPnts:=PointCount;
      LayA[CurrentLayer].IslandsN:=IslandCount;
    end {shape type...Polygon}
    else

    (********************************)
    If ((ShapeType=8){MultiPoint 1 Part of Many Points}
          or(ShapeType=18)
          or(ShapeType=28)) then
    begin
      ShapeNumber :=0;
      while (not (eof(ShapeFileIn))) do
      begin
        BlockRead(ShapeFileIn, ICOIn, 4); {Record Number}
        inc(ShapeNumber);
        NumShape:=SwapShapeInteger(ICOIn);{Store total for later}
        Setlength(LayA[CurrentLayer].LyrShp,ShapeNumber+1);
         {  Counter status}
        HintsLabel.Caption:=Inttostr(NumShape);
        Application.ProcessMessages;
        BlockRead(ShapeFileIn, ByteArray, 4); {Content length}
        FileSizeCheck:=SwapShapeByte;
        { ShapeViewMemo.Lines.Add('Content length: ' + Inttostr(SwapShapeInteger(ByteArray)));}
        Setlength(LayA[CurrentLayer].LyrShp[ShapeNumber].AAttributes,0);
        BlockRead(ShapeFileIn, BufI, 4); {Shapetype}
        {ShapeViewMemo.Lines.Add('Shapetype: ' + Inttostr(BufI));}
              {If not same as Shapetype then error}
        {XMIN,YMIN,XMAX,YMAX:Double;}
        BlockRead(ShapeFileIn, dXMIN, 8);
        {ShapeViewMemo.Lines.Add('XMIN: '  + Floattostr(dXMIN));}
        BlockRead(ShapeFileIn, dYMIN, 8);
        {ShapeViewMemo.Lines.Add('YMIN: '  + Floattostr(dXMIN));}
        BlockRead(ShapeFileIn, dXMAX, 8);
         {ShapeViewMemo.Lines.Add('XMAX: '  + Floattostr(dXMAX));}
        BlockRead(ShapeFileIn, dYMAX, 8);
         {ShapeViewMemo.Lines.Add('YMAX: '  + Floattostr(dYMAX));}
         {LayA[].ShpLayer.LyrShp[].ShpObj.PARA[PartsN #].PAR.PA[PPA[PartsN #]].Pnts.Xn Yn Zn Mn}
        LayA[CurrentLayer].LyrShp[ShapeNumber].XMin:= dXMIN;
        LayA[CurrentLayer].LyrShp[ShapeNumber].YMin:= dYMIN;
        LayA[CurrentLayer].LyrShp[ShapeNumber].XMax:= dXMAX;
        LayA[CurrentLayer].LyrShp[ShapeNumber].YMax:= dYMAX;
        Numparts:=1;
        LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN:=1;{Numparts}
         {IslandCount:= IslandCount+(Numparts-1);}
        {CHANGE the array size to Numparts}
        {SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PPA,Numparts+1);}
        SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA,Numparts+1);
        BlockRead(ShapeFileIn, NumPoints, 4); {NumPoints}
        LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
        PointCount:=PointCount+NumPoints;{Total points for File}
        SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1].PA,NumPoints+1 );

        {GET the Parts array data}
        PartNumber:=1;
        PointNumber:=1;
         {Get the Parts array and use to divide lines}
        for I := 1 to NumPoints do
        begin {2 points internally}
          BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
          LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Xd:=dXTemp;
          BlockRead(ShapeFileIn, dYTemp, 8);
          LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Yd:=dYTemp;
          inc(PointNumber);
        end;
        If (ShapeType=18) then {Z 18 only}
        begin
          BlockRead(ShapeFileIn, dXMIN, 8);
          {ShapeViewMemo.Lines.Add('XMAX: '  + Floattostr(dXMAX));}
          BlockRead(ShapeFileIn, dYMAX, 8);
          {ShapeViewMemo.Lines.Add('YMAX: '  + Floattostr(dYMAX));}
          {LayA[].ShpLayer.LyrShp[].ShpObj.PARA[PartsN #].PAR.PA[PPA[PartsN #]].Pnts.Xn Yn Zn Mn}
{          LayA[CurrentLayer].LyrShp[ShapeNumber].ZMin:= dXMIN;
          LayA[CurrentLayer].LyrShp[ShapeNumber].ZMax:= dXMAX;}
          for I := 1 to NumPoints do
          begin {2 points internally}
            BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
{            LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Zd:=dXTemp;}
          end;
        end;
        If (ShapeType>8) then {18 and 28}
        begin
          BlockRead(ShapeFileIn, dXMIN, 8);
          { ShapeViewMemo.Lines.Add('XMAX: '  + Floattostr(dXMAX));}
          BlockRead(ShapeFileIn, dYMAX, 8);
          {ShapeViewMemo.Lines.Add('YMAX: '  + Floattostr(dYMAX));}
          {LayA[].ShpLayer.LyrShp[].ShpObj.PARA[PartsN #].PAR.PA[PPA[PartsN #]].Pnts.Xn Yn Zn Mn}
{          LayA[CurrentLayer].LyrShp[ShapeNumber].MMin:= dXMIN;
          LayA[CurrentLayer].LyrShp[ShapeNumber].MMax:= dXMAX;}
          for I := 1 to NumPoints do
          begin {2 points internally}
            BlockRead(ShapeFileIn, dXTemp, 8); {POINTS....}
{            LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[PartNumber].PA[PointNumber].Md:=dXTemp;}
          end;
        end;
{COMPUTE Actual Shape Object Size}
if ((Shapetype = 8)) then
      FileSizeChecker := (18{22}
      +(LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN* 2)
      + (LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN  * 8)
      {+4}{this header data})
else if ((Shapetype = 18)) then
      FileSizeChecker := (18{22}+16
      +(LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN* 2)
      + (LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN  * 16)
      {+4}{this header data})
else {if ((Shapetype = 28)) then}
      FileSizeChecker := (18{22}+8
      +(LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN* 2)
      + (LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN  * 12)
      {+4}{this header data});
        If ((FileSizeCheck > FileSizeChecker)) then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          FileSizeChecker:=(FileSizeChecker * 2);
          for I:= 1 to FileSizeCheck-FileSizeChecker do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end;
       { FileSizeChecker:=FileSizeCheck*2;
        If FileSizeCheck > FileSizeChecker then
        begin
          FileSizeCheck:=(FileSizeCheck * 2);
          for I:= 1 to FileSizeCheck-20 do
          begin
            BlockRead(ShapeFileIn, BufByte,1);
          end;
        end; }
      end; {For II File}
      LayA[CurrentLayer].ShapeN:=NumShape;
      LayA[CurrentLayer].TotalPnts:=PointCount;
      LayA[CurrentLayer].IslandsN:=0;{IslandCount;}
    end {shape type...Multi Point}
    else
    If (ShapeType=31) then
    begin  {Fan or Strip.. Read into Mesh}
      Result:=False;
      HintsLabel.Caption:='Error loading Shape Fan or Strip';
      {DoMessages(16);}{16, "Error loading Shape (*.shp) file"}
    end else Result:=False;

    If ShapeNumber <> NumShape then Result:=False
       else Result:=True;

    If (Result=True) then
    begin
    {Make Attributes .. part 1}
     LayA[CurrentLayer].LayerColor:=
     RGB(Random(255),Random(255),Random(255));
     LayA[CurrentLayer].OutLineColor:=
          LayA[CurrentLayer].LayerColor;
     LayA[CurrentLayer].PolygonAntialiased:=False;
     LayA[CurrentLayer].PolyFilled:=False;
     LayA[CurrentLayer].PolyFillType:=0; {PolyFillType}
     LayA[CurrentLayer].PolyFillFile:='';
     LayA[CurrentLayer].UseOutlinePoly:=False;
     LayA[CurrentLayer].LineAlphaPosition:=255;
     LayA[CurrentLayer].FillAlphaPosition:=127;
     LayA[CurrentLayer].LineSize:=1.0;
     LayA[CurrentLayer].PointSize:=2;
     LayA[CurrentLayer].OtsNameEditText:='Nada.ots';
     LayA[CurrentLayer].StippleColorCount:=1;
     LayA[CurrentLayer].UseStippleStep:=False;
     LayA[CurrentLayer].StippleStep:=1.0;
     SetLength(LayA[CurrentLayer].StippleColorArray,1);
     LayA[CurrentLayer].StippleColorArray[0]:=ClBlack;
     LayA[CurrentLayer].CanvasLineSize:=0;
    {Make Attributes .. If fileexists then read it}
      SetLength(Mapa,LayersLoaded+1);
      Mapa[CurrentLayer].SymLayerSymboled:=1;
      Mapa[CurrentLayer].SymLayerBeginSize:=5;
      Mapa[CurrentLayer].SymLayerEndSize:=25;
      Mapa[CurrentLayer].SymLayerClasses:=5;
      Mapa[CurrentLayer].SymLayerStartColor:=clLime;
      Mapa[CurrentLayer].SymLayerFinishColor:=clGreen;
      Mapa[CurrentLayer].isSymLayerEditable:=True;
      Mapa[CurrentLayer].isSymLayerOutlined:=True;
      SetDisplayStyle(CurrentLayer);
      Mapa[CurrentLayer].SymLayerLabeled:=0;
      Mapa[CurrentLayer].SymLayerLabelBackColor:=clWhite;
      Mapa[CurrentLayer].isSymLayerLabelColored:=True;
      Mapa[CurrentLayer].SymFont:=HintsLabel.Font;{ShapeTypeEdit.Font;}
      Mapa[CurrentLayer].labelHeight:=0;
      Mapa[CurrentLayer].labelAngle:=0;
      Mapa[CurrentLayer].Field:=0;
      SetLength(Mapa[CurrentLayer].SymLayerClassBreaks,6);
      For I:= 0 to 5 do
          Mapa[CurrentLayer].SymLayerClassBreaks[i]:=I;
      For I:= 1 to NumShape+1 do
      begin
        SetLength(Mapa[CurrentLayer].LyrSym,I);
        HintsLabel.Caption :=Inttostr(I);
      end;
    end;
    If FileExists(ChangeFileExt({LayA[CurrentLayer].Path}
    ExtractFilePath(ShpFileName){ProjectPath}
    +LayA[CurrentLayer].Filename ,'.att')) then
       ReadShapeAttFile(
    ExtractFilePath(ShpFileName){ProjectPath}
       {LayA[CurrentLayer].Path}+LayA[CurrentLayer].Filename,CurrentLayer);
{    LayA[CurrentLayer].Filename:=ExtractFileName(ShpFileName);
    LayA[CurrentLayer].Path:=ExtractFilePath(ShpFileName);}

    end;

{  End;}{Finally Begin}
  Finally
      CloseFile(ShapeFileIn);
  end;{Finally}
end; {PROCEDURE }
(*************************************************************)
{Write Attributes to a ShapeFileName.att file}
{SetLength(Mapa,LayersLoaded+1);
 SetLength(Mapa[CurrentLayer].LyrSym,NumShape+1);}
procedure TShapeLoaderForm.WriteShapeAttFile(FileName:String;Which:Integer);
var
    ShapeFileIn: file;
    ShapeFileInT: Textfile;
    I,LayerDo, NumRead:Integer;
Begin
    Try
    FileName:=ChangeFileExt(FileName,'.att');
    AssignFile(ShapeFileIn, Filename);
    Rewrite(ShapeFileIn, 1); { Record size = 1 }
    AssignFile(ShapeFileInT, ChangeFileExt(FileName,'.atx'));
    Rewrite(ShapeFileInT);
    Application.ProcessMessages;
      LayerDo:=Which;
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerSymboled, SizeOf(Mapa[LayerDo].SymLayerSymboled), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerBeginSize, SizeOf(Mapa[LayerDo].SymLayerBeginSize), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerEndSize, SizeOf(Mapa[LayerDo].SymLayerEndSize), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerClasses, SizeOf(Mapa[LayerDo].SymLayerClasses), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerStartColor, SizeOf(Mapa[LayerDo].SymLayerStartColor), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerFinishColor, SizeOf(Mapa[LayerDo].SymLayerFinishColor), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].isSymLayerEditable, SizeOf(Mapa[LayerDo].isSymLayerEditable), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].isSymLayerOutlined, SizeOf(Mapa[LayerDo].isSymLayerOutlined), NumRead);
{      SetDisplayStyle(CurrentLayer);}
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerLabeled, SizeOf(Mapa[LayerDo].SymLayerLabeled), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerLabelBackColor, SizeOf(Mapa[LayerDo].SymLayerLabelBackColor), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].isSymLayerLabelColored, SizeOf(Mapa[LayerDo].isSymLayerLabelColored), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymFont, SizeOf(Mapa[LayerDo].SymFont), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].labelHeight, SizeOf(Mapa[LayerDo].labelHeight), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].labelAngle, SizeOf(Mapa[LayerDo].labelAngle), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].Field, SizeOf(Mapa[LayerDo].Field), NumRead);
{      SetLength(Mapa[CurrentLayer].SymLayerClassBreaks,SymLayerClasses+1);}
      For I:= 0 to Mapa[LayerDo].SymLayerClasses do
    BlockWrite(ShapeFileIn, Mapa[LayerDo].SymLayerClassBreaks[i], SizeOf(Mapa[LayerDo].SymLayerClassBreaks[i]), NumRead);

  For I:=1 to Laya[LayerDo].ShapeN do
  Begin
    Application.ProcessMessages;
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymSymboled, SizeOf(Mapa[LayerDo].LyrSym[I].SymSymboled), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLabeled, SizeOf(Mapa[LayerDo].LyrSym[I].SymLabeled), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymClassSize, SizeOf(Mapa[LayerDo].LyrSym[I].SymClassSize), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymStyle, SizeOf(Mapa[LayerDo].LyrSym[I].SymStyle), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLineStyle, SizeOf(Mapa[LayerDo].LyrSym[I].SymLineStyle), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLineWidth, SizeOf(Mapa[LayerDo].LyrSym[I].SymLineWidth), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLabelBackColor, SizeOf(Mapa[LayerDo].LyrSym[I].SymLabelBackColor), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLineColor, SizeOf(Mapa[LayerDo].LyrSym[I].SymLineColor), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymBrushColor, SizeOf(Mapa[LayerDo].LyrSym[I].SymBrushColor), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].isSymOutlined, SizeOf(Mapa[LayerDo].LyrSym[I].isSymOutlined), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].isSymLabelSet, SizeOf(Mapa[LayerDo].LyrSym[I].isSymLabelSet), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].isSymLabelColored, SizeOf(Mapa[LayerDo].LyrSym[I].isSymLabelColored), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymFont, SizeOf(Mapa[LayerDo].LyrSym[I].SymFont), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].labelHeight, SizeOf(Mapa[LayerDo].LyrSym[I].labelHeight), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].labelAngle, SizeOf(Mapa[LayerDo].LyrSym[I].labelAngle), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].HAlign, SizeOf(Mapa[LayerDo].LyrSym[I].HAlign), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].VAlign, SizeOf(Mapa[LayerDo].LyrSym[I].VAlign), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].LabelX, SizeOf(Mapa[LayerDo].LyrSym[I].LabelX), NumRead);
    BlockWrite(ShapeFileIn, Mapa[LayerDo].LyrSym[I].LabelY, SizeOf(Mapa[LayerDo].LyrSym[I].LabelY), NumRead);
  End;
  For I:=1 to Laya[LayerDo].ShapeN do
  Begin
    Writeln(ShapeFileInT,
           Mapa[LayerDo].LyrSym[I].SymObjlabelFieldstring);
  end;
    Finally
      CloseFile(ShapeFileIn);
      CloseFile(ShapeFileInT);
    end;{Finally}
End;
(***********************************************************)
      {Load the attributes}
      {Load an attribute file for each layer if it exists}
      {No need to Setlength..much the memory exists, just not changed}
      {Load the data and replace the layers default info}
procedure TShapeLoaderForm.ReadShapeAttFile(FileName:String;Which:Integer);
var
    ShapeFileIn: file;
    ShapeFileInT: Textfile;
    I,LayerDo, NumRead:Integer;
Begin
    Try
    FileName:=ChangeFileExt(FileName,'.att');
    AssignFile(ShapeFileIn, Filename);
    Reset(ShapeFileIn, 1); { Record size = 1 }
    AssignFile(ShapeFileInT, ChangeFileExt(FileName,'.atx'));
    Reset(ShapeFileInT);
    Application.ProcessMessages;
    LayerDo:=Which;
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerSymboled, SizeOf(Mapa[LayerDo].SymLayerSymboled), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerBeginSize, SizeOf(Mapa[LayerDo].SymLayerBeginSize), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerEndSize, SizeOf(Mapa[LayerDo].SymLayerEndSize), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerClasses, SizeOf(Mapa[LayerDo].SymLayerClasses), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerStartColor, SizeOf(Mapa[LayerDo].SymLayerStartColor), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerFinishColor, SizeOf(Mapa[LayerDo].SymLayerFinishColor), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].isSymLayerEditable, SizeOf(Mapa[LayerDo].isSymLayerEditable), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].isSymLayerOutlined, SizeOf(Mapa[LayerDo].isSymLayerOutlined), NumRead);
{      SetDisplayStyle(CurrentLayer);}
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerLabeled, SizeOf(Mapa[LayerDo].SymLayerLabeled), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerLabelBackColor, SizeOf(Mapa[LayerDo].SymLayerLabelBackColor), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].isSymLayerLabelColored, SizeOf(Mapa[LayerDo].isSymLayerLabelColored), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymFont, SizeOf(Mapa[LayerDo].SymFont), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].labelHeight, SizeOf(Mapa[LayerDo].labelHeight), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].labelAngle, SizeOf(Mapa[LayerDo].labelAngle), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].Field, SizeOf(Mapa[LayerDo].Field), NumRead);
SetLength(Mapa[LayerDo].SymLayerClassBreaks,
          Mapa[LayerDo].SymLayerClasses+1);
      For I:= 0 to Mapa[LayerDo].SymLayerClasses do
    BlockRead(ShapeFileIn, Mapa[LayerDo].SymLayerClassBreaks[i], SizeOf(Mapa[LayerDo].SymLayerClassBreaks[i]), NumRead);

  For I:=1 to Laya[LayerDo].ShapeN do
  Begin
    Application.ProcessMessages;
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymSymboled, SizeOf(Mapa[LayerDo].LyrSym[I].SymSymboled), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLabeled, SizeOf(Mapa[LayerDo].LyrSym[I].SymLabeled), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymClassSize, SizeOf(Mapa[LayerDo].LyrSym[I].SymClassSize), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymStyle, SizeOf(Mapa[LayerDo].LyrSym[I].SymStyle), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLineStyle, SizeOf(Mapa[LayerDo].LyrSym[I].SymLineStyle), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLineWidth, SizeOf(Mapa[LayerDo].LyrSym[I].SymLineWidth), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLabelBackColor, SizeOf(Mapa[LayerDo].LyrSym[I].SymLabelBackColor), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymLineColor, SizeOf(Mapa[LayerDo].LyrSym[I].SymLineColor), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymBrushColor, SizeOf(Mapa[LayerDo].LyrSym[I].SymBrushColor), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].isSymOutlined, SizeOf(Mapa[LayerDo].LyrSym[I].isSymOutlined), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].isSymLabelSet, SizeOf(Mapa[LayerDo].LyrSym[I].isSymLabelSet), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].isSymLabelColored, SizeOf(Mapa[LayerDo].LyrSym[I].isSymLabelColored), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].SymFont, SizeOf(Mapa[LayerDo].LyrSym[I].SymFont), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].labelHeight, SizeOf(Mapa[LayerDo].LyrSym[I].labelHeight), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].labelAngle, SizeOf(Mapa[LayerDo].LyrSym[I].labelAngle), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].HAlign, SizeOf(Mapa[LayerDo].LyrSym[I].HAlign), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].VAlign, SizeOf(Mapa[LayerDo].LyrSym[I].VAlign), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].LabelX, SizeOf(Mapa[LayerDo].LyrSym[I].LabelX), NumRead);
    BlockRead(ShapeFileIn, Mapa[LayerDo].LyrSym[I].LabelY, SizeOf(Mapa[LayerDo].LyrSym[I].LabelY), NumRead);
  End;
  For I:=1 to Laya[LayerDo].ShapeN do
  Begin
    Readln(ShapeFileInT,
           Mapa[LayerDo].LyrSym[I].SymObjlabelFieldstring);
  end;
    Finally
      CloseFile(ShapeFileIn);
      CloseFile(ShapeFileInT);
    end;{Finally}
End;

procedure TShapeLoaderForm.SetDisplayStyle(LayerToDo:Integer);
Begin
  MapA[LayerToDo].SymLayerLineStyle:=(LayerToDo mod 6)-1;
  MapA[LayerToDo].SymLayerLineWidth:=1;
  MapA[LayerToDo].SymLayerLineColor :=
       SetMyColor(( LayerToDo+1));
  MapA[LayerToDo].SymLayerBrushColor :=
       SetMyColor(( LayerToDo));
  If ( (LayA[LayerToDo].ShpType=1)
    or (LayA[LayerToDo].ShpType=8)) then
  MapA[LayerToDo].SymLayerStyle:=(LayerToDo mod 5)-1
  else   MapA[LayerToDo].SymLayerStyle:=(LayerToDo mod 7)-1;
End;

Function TShapeLoaderForm.SetMyColor(InColor:Integer):TColor;
Begin
{Result:=ColorArray[(InColor mod 255)]}
InColor:= (InColor mod 14);
Case InColor of
1: Result:=clMaroon;
2: Result:=clGreen;
3: Result:=clOlive;
4: Result:=clNavy;
5: Result:=clPurple;
6: Result:=clTeal;
7: Result:=clGray;
8: Result:=clSilver;
9: Result:=clRed;
10: Result:=clLime;
11: Result:=clYellow;
12: Result:=clBlue;
13: Result:=clFuchsia;
14: Result:=clAqua;
else Result:=clBlack;
End;
End;
(***********************************************************)
(***********************************************************)

Function TShapeLoaderForm.LoadHeightBase(FileName:String):Boolean;
Begin
Result:=False;
    {DemPath:= ExtractFilePath(OpenDialog.FileName);
    DemName := ExtractFileName(OpenDialog.FileName);
    .bt  .bin  LoadHeightBase}
End;
(*************************************************************)






end.
