{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit TreeConstants;

interface

uses VectorGeometry;

const IDS_PLUGINNAME = 0;   {dll data tags}
      IDS_COPYRIGHT = 1;
      IDS_DESCRIPTION = 2;
      TREAL_VERSION = '0.21';  {File loaders and Captions}
      FLARE_RESOLUTION = 10;  {Bole divided always into 10 more sections?}
      BigLeafScale = 2.2;  {Scaled size to enlarge Big leaves}
      BigLeavesToMake =2000; {# of leaves made for Ranging}
      BigLeafOffSet = 100;{Camera distance before Affected}
    { Original Registry keys .. now in .tdf File
      TREAL_REGISTRY_KEY = '\Software\Green Hill Software\TReal\';
      TREAL_LAST_DEFINITION_FILE = 'Last Loaded Definition File';
      TREAL_RANDSEED = 'Random Seed Number';
      TREAL_SEASON = 'Season';
      TREAL_HEALTH = 'Health'; }

var
  BigTreeRat,BigTreeRatCount, BigTotalLeaves:Integer;
  BoleMade,{Interim cheater code}
   {Stop tree processing, AVI termination}
                              {GlsViewerCancelled,}
                              { GlsDemoCancelled,}  {Tree test form}
  GlsUserCancelled: Boolean;  {TGlsProgressForm}
  {Animation toggles : }
  AnimationActive, RotationActive, DistanceActive, WindAnimationActive,
  DisplayWithLeaves,{Toggle for Level Branch display}
  DemoTreePlanted, TreePlanted {Indicates already loaded... OBE}
  :Boolean;
  MemoryCapacity:Integer; {Tree Crash Test}

  {Form location storage}
  aGlsTreeFormX,aGlsTreeFormY,
  GlsTrealViewerFormX,GlsTrealViewerFormY,
  ATreeDemoFormX,ATreeDemoFormY,
  MathingsFormX,MathingsFormY,
  LSystemFormX,LSystemFormY,

  Bolebusted, {trying to fix the bark texture}
  RandomTreeSeedNumber, {storage & passing}
  GlobalLevelsNumber,   {storage & passing}
  WindSign,             {storage & passing}
  Anime360Counter,      {AVI }
  AnimationDistance  :Integer;
  AnimationComputedDistance:Double;
  {LeafQuality 1= as defined, > 1.0 is smaller leaves and More of them
  for Range Degradation, 0.1..1 1=CLOSE up  0.1=FAR away
   # Leaves *LeafQuality and Size  SQRT(LeafQuality)}

  GlsPath, GlsTdfPath, GlsDataPath:String;

implementation


end.
