 //?Marcus?
unit UFrmLMMWizard;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ActnList,
  Menus, ExtCtrls,GLSCene,GLVectorFileObjects,GLMeshOptimizer, Buttons;

type
  TfrmLMMWizard = class(TForm)
    PageControl1: TPageControl;
    tsWelcome: TTabSheet;
    tsFile1: TTabSheet;
    tsFile2: TTabSheet;
    Label1: TLabel;
    tsCompleted: TTabSheet;
    File1: TEdit;
    btnFile1: TButton;
    chkOptimize: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    File2: TEdit;
    btnFile2: TButton;
    Label7: TLabel;
    Panel1: TPanel;
    Button3: TButton;
    ActionList1: TActionList;
    actNext: TAction;
    actCancel: TAction;
    Button4: TButton;
    Label8: TLabel;
    OpenDialog1: TOpenDialog;
    actOpen: TAction;
    Label9: TLabel;
    LMMHelpBtn: TSpeedButton;
    procedure actNextUpdate(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actNextExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LMMHelpBtnClick(Sender: TObject);
  private
    { Private declarations }
    Working:Boolean;
  public
    { Public declarations }
    DestFreeForm: TGLFreeForm;
  end;

var
  frmLMMWizard: TfrmLMMWizard;

implementation

uses dtmPOFvar, ULightMapTools;

{$R *.dfm}

procedure TfrmLMMWizard.FormCreate(Sender: TObject);
var
   t: integer;
begin
  top := frmLMMWizardY;{0;}
  left := frmLMMWizardX;{488;}
  Working:=False;
     for t := 0 to PageControl1.PageCount-1 do
          PageControl1.Pages[t].TabVisible := false;
     PageControl1.ActivePage :=tsWelcome;
end;

procedure TfrmLMMWizard.actCancelExecute(Sender: TObject);
begin
     Close;
end;

procedure TfrmLMMWizard.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmLMMWizardX := frmLMMWizard.left;
  frmLMMWizardY := frmLMMWizard.top;
  DoSaver;
     Action := caFree;
end;
procedure TfrmLMMWizard.LMMHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(1001);
end;

procedure TfrmLMMWizard.actNextUpdate(Sender: TObject);
var
   ena : boolean;
begin
     ena := true;
     if PageControl1.ActivePage = tsFile1 then
        ena := File1.Text<>''
     else
     if PageControl1.ActivePage = tsFile2 then
        ena := File2.Text<>''
     else
     if PageControl1.ActivePage = tsCompleted then
        ena := false;

     actNext.Enabled := ena;
end;

procedure TfrmLMMWizard.actOpenExecute(Sender: TObject);
begin
     if OpenDialog1.Execute then
     begin
          if PageControl1.ActivePage = tsFile1 then
             File1.Text := OpenDialog1.FileName
          else
          if PageControl1.ActivePage = tsFile2 then
             File2.Text := OpenDialog1.FileName
     end;
end;

procedure TfrmLMMWizard.actNextExecute(Sender: TObject);
begin
If Working then begin end else
begin
     if PageControl1.ActivePage = tsFile2 then
     begin
       Working:=True;
       Panel1.Caption:='Working... Please wait';
          DestFreeForm.MeshObjects.Clear;
          DestFreeForm.MaterialLibrary.Materials.Clear;
          DestFreeForm.LightmapLibrary.Materials.Clear;
          Chdir(ExtractFilePath(File1.Text));
          DestFreeForm.LoadFromFile(File1.Text);

{          if chk1Lightmap.Checked then
          begin
               DestFreeForm.MeshObjects[0].FaceGroups[0].LightMapIndex
          end;
}

          if chkOptimize.Checked then
             OptimizeMesh(DestFreeForm.MeshObjects,[mooVertexCache, mooSortByMaterials,mooMergeObjects]);

          ImportLMMLightMap(DestFreeForm,File2.Text,chkOptimize.Checked);
          Working:=False;
          Panel1.Caption:='';
     end else
     if PageControl1.ActivePage = tsCompleted then Close
     else
     PageControl1.SelectNextPage(true{,false});
end;
end;





end.
